/**
 ** sparkSituationAssessmentCodels.cc
 **
 ** Codels called by execution task sparkMainTask
 **
 ** Author: E. Akin Sisbot
 ** Date: Aug 10
 **
 **/

#include <portLib.h>

#include "server/sparkHeader.h"
#include "sparkm3d.h"

#include "libeuler/pomEuler.h"

#ifdef ORO
#include "sparkOro.h"
#endif

#if defined(USE_MIGHTABILITY_MAPS)
extern agents_activity_facts Ag_Activity_Fact[MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int STOP_AGENT_STATE_ANALYSIS;
extern int PRINT_AGENT_STATE_FACTS;
extern Agent_Activity_fact_by_names Hum_facts_by_name[MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int NewDataForASA;
extern int SHOW_OBJECT_FACTS;
extern int SHOW_OBJ_FACTS_BY_ARROW;
extern int OBJ_IS_VISIBLE_FOR_AGENT[MAXI_NUM_OF_ALLOWED_OBJECTS_IN_ENV][MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int OBJ_IS_REACHABLE_FOR_AGENT[MAXI_NUM_OF_ALLOWED_OBJECTS_IN_ENV][MAXI_NUM_OF_AGENT_FOR_HRI_TASK][MAXI_NUM_OF_HANDS_OF_AGENT];

#endif

// static SPARK_ALL_REACHABILITIES *gAllReachs = NULL;
// static SPARK_ALL_OBJECT_STATES *gPrevObjectStates = NULL;

/* ----------------- INTERNAL FUNCTIONS -------------------- */

// static int object_visibility_state(p3d_rob *object, HRI_AGENT *agent, 
// 				   double elevation, double azimuth,
// 				   int visThr,
// 				   SPARK_VISIBILITY *visibility)
// {
//   configPt sourceQ, savedQ;
//   p3d_rob * robot = NULL;
//   p3d_jnt *panJnt = NULL, *tiltJnt = NULL;
//   int visResult;
  
//   // MOVE THE AGENT TO LOOK AT THE TARGET
  
//   robot  = agent->robotPt;
//   panJnt  = robot->joints[agent->perspective->pan_jnt_idx];
//   tiltJnt = robot->joints[agent->perspective->tilt_jnt_idx];
 
  
//   if( (robot==NULL) || (panJnt==NULL) || (tiltJnt==NULL) ) {
//     printf("In %s:%d, bad input\n",__FILE__,__LINE__);
//     return FALSE;
//   }
  
//   sourceQ = MY_ALLOC(double, robot->nb_dof); /* ALLOC */
//   savedQ  = MY_ALLOC(double, robot->nb_dof); /* ALLOC */
  
//   p3d_get_robot_config_into(robot, &sourceQ);
//   p3d_get_robot_config_into(robot, &savedQ);
  
//   /* TURN PAN */
//   azimuth = azimuth + sourceQ[panJnt->index_dof]; // Relative to absolute angle

//   if(panJnt->dof_data[0].vmin > azimuth) {
//     if(panJnt->dof_data[0].vmax < azimuth - M_2PI) {
//       if(ABS(panJnt->dof_data[0].vmin-azimuth) < ABS(panJnt->dof_data[0].vmax-azimuth)) {
// 	sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmin;
//       }
//       else{
// 	sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmax;
//       } 
//     }
//     else{
//       sourceQ[panJnt->index_dof] = azimuth - M_2PI; 
//     }	
//   }
//   else{
//     if(panJnt->dof_data[0].vmax < azimuth) {
//       if(panJnt->dof_data[0].vmin > azimuth - M_2PI) {
// 	if(ABS(panJnt->dof_data[0].vmin-azimuth) < ABS(panJnt->dof_data[0].vmax-azimuth)) {
// 	  sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmin;
// 	}
// 	else{
// 	  sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmax;
// 	}
//       } 
//       else{
// 	sourceQ[panJnt->index_dof] = azimuth- M_2PI; 
//       }	
//     }
//     else{
//       sourceQ[panJnt->index_dof] = azimuth; 
//     }
//   } 
  
//   /* TURN TILT */
//   elevation = elevation + sourceQ[tiltJnt->index_dof]; // Relative to absolute angle
 
//   if(tiltJnt->dof_data[0].vmin > elevation) {
//     sourceQ[tiltJnt->index_dof] = tiltJnt->dof_data[0].vmin;
//   }
//   else{
//     if(tiltJnt->dof_data[0].vmax < elevation) {
//       sourceQ[tiltJnt->index_dof] = tiltJnt->dof_data[0].vmax;
//     }
//     else{
//       sourceQ[tiltJnt->index_dof] = elevation;  
//     }
//   }
  
//   p3d_set_and_update_this_robot_conf(robot, sourceQ);  
  
//   // VISIBILITY TEST
  
//   visResult = hri_is_object_visible(agent, object, visThr, FALSE, FALSE);

//   switch(visResult) {
//   case 0: // INVISIBLE
//     *visibility = INVISIBLE;
//     break;
//   case 1: // VISIBLE
//     *visibility = VISIBLE;
//     break;
//   }
//   p3d_set_and_update_this_robot_conf(robot, savedQ);
  
//   MY_FREE(savedQ, double, robot->nb_dof); /* FREE */
//   MY_FREE(sourceQ, double, robot->nb_dof); /* FREE */

//   return TRUE;
// }

// /* sparkIsVisibleMain  -  codel EXEC of IsVisible
//    Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkIsVisibleMain(SPARK_VISREACH_QUERY *visQuery, SPARK_VISREACH_RESULT *visResult, int *report)
// {
//   p3d_rob * target = NULL;
//   HRI_AGENT * sourceAgent = NULL;
//   int i;
//   double elevation = 0, azimuth = 0;
//   SPARK_VISIBILITY visibility;
//   int visibPl;


//   // -----Performance evaluation
//   //struct timeval tvBegin, tvEnd, tvDiff;
//   //gettimeofday(&tvBegin, NULL);
//   // -----

//   if(gAgents == NULL) {
//     *report = S_spark_NOT_INITIALIZED;
//     return ETHER;
//   }
  
//   // Find the target object
//   for(i=0; i<gEnv->nr; i++) {
//     if( strcasestr(gEnv->robot[i]->name, visQuery->target.name) ) {
//       target = gEnv->robot[i];
//       break;
//     }
//   }
//   if(target == NULL) {
//     *report = S_spark_OBJECT_NOT_FOUND;
//     return ETHER;
//   }
  
//   //Find the source agent
//   for(i=0; i<gAgents->all_agents_no; i++) {
//     if( strcasestr(gAgents->all_agents[i]->robotPt->name, visQuery->agent.name) ) {
//       sourceAgent = gAgents->all_agents[i];
//       break;
//     }
//   }
//   if(sourceAgent == NULL) {
//     *report = S_spark_AGENT_NOT_FOUND;
//     return ETHER;
//   }
  
//   hri_object_visibility_placement(sourceAgent, target, &visibPl, &elevation, &azimuth);
//   object_visibility_state(target, sourceAgent, elevation, azimuth, SPARK_DEFAULT_VISIBILITY_RATIO, &visibility);
  
//   switch((SPARK_VISIBILITY_PLACEMENT) visibPl) {
//   case FOA: //in FOA 
//     strcpy(visResult->result1.name,"FOA");
//     break;
//   case FOV: //in FOV 
//     strcpy(visResult->result1.name,"FOV");
//     break;
//   case OOF: //in OOF
//     strcpy(visResult->result1.name,"OOF");
//     break;
//   default: //should never come here
//     printf("Problem in visibility_placement\n");
//     break;
//   }
  
//   switch(visibility) {
//   case INVISIBLE:
//     strcpy(visResult->result2.name,"INVISIBLE");
//     break; 
//   case VISIBLE:
//     strcpy(visResult->result2.name,"VISIBLE");
//     break;
//   }

//   // -----Performance evaluation
//   //gettimeofday(&tvEnd, NULL);
//   //timeval_subtract(&tvDiff, &tvEnd, &tvBegin);
//   //printf("%ld.%06ld\n", tvDiff.tv_sec, tvDiff.tv_usec);
//   // -------
  
//   *report = OK;
//   return ETHER;
// }

// SPARK_REACHABILITY spark_object_reachability_state(p3d_rob * object, HRI_AGENT *agent)
// {
//   int reached = FALSE;
//   configPt qs, q;
//   p3d_vector3 Tcoord[3];
//   SPARK_REACHABILITY reachability;

//   // Target object
//   Tcoord[0][0] = object->joints[1]->abs_pos[0][3];      
//   Tcoord[0][1] = object->joints[1]->abs_pos[1][3];     
//   Tcoord[0][2] = object->joints[1]->abs_pos[2][3];
  
//   if(D3D(Tcoord[0][0],Tcoord[0][1],Tcoord[0][2],
// 	 agent->robotPt->joints[1]->abs_pos[0][3],
// 	 agent->robotPt->joints[1]->abs_pos[1][3],
// 	 agent->robotPt->joints[1]->abs_pos[2][3]) > 1.5) {
    
//     reachability = UNREACHABLE;
//   }

//   GIK_VIS = 500;
  
//   qs = MY_ALLOC(double, agent->robotPt->nb_dof); /* ALLOC */
//   q  = MY_ALLOC(double, agent->robotPt->nb_dof); /* ALLOC */
  
//   p3d_get_robot_config_into(agent->robotPt, &qs); /* Saving agent config */
  
//   reached = hri_agent_single_task_manip_move(agent, GIK_LATREACH, object, &q);
  
//   if(agent->manip->type == TWO_ARMED) {
//     p3d_set_and_update_this_robot_conf(agent->robotPt, qs);
//     reached = hri_agent_single_task_manip_move(agent, GIK_RATREACH, object, &q); 
//   }
//   p3d_set_and_update_this_robot_conf(agent->robotPt, q);
//   p3d_col_activate_robot(agent->robotPt);
  
//   // In the end of the motion check if there is a collision
//   if(!p3d_col_test_robot(agent->robotPt, 0)) {
//     // Check if the collision is with the object
//     p3d_col_deactivate_robot_robot(agent->robotPt, object);  
//     if(!p3d_col_test_robot(agent->robotPt, 0)) {
//       // The robot colliding another object
//       if(reached)
// 	reachability = REACHABLE_WITH_COLLISION;
//       else
// 	reachability = UNREACHABLE;
//     }
//     else {
//       // Robot collides only with the target
//       // That means it is reached
//       reachability = REACHABLE;
//     }
//     p3d_col_activate_robot_robot(agent->robotPt, object); 
//   }
//   else {
//     if(reached) {      
//       reachability = REACHABLE;
//     }
//     else {
//       reachability = UNREACHABLE;
//     }
//   }

//   p3d_set_and_update_this_robot_conf(agent->robotPt,qs);
  
//   MY_FREE(q, double , agent->robotPt->nb_dof); /* FREE */
//   MY_FREE(qs, double, agent->robotPt->nb_dof); /* FREE */
  
//   return reachability;
// }

// /* ----------------- END INTERNAL FUNCTIONS ----------------- */

/* sparkUpdateOneSituationAssessmentMain  -  codel EXEC of UpdateOneSituationAssessment
 
   this function uses the same processing used in compute_geometric_facts of libhri. Onto update should be managed better.
*/
ACTIVITY_EVENT
sparkUpdateControlOneSituationAssessmentMain(SPARK_SPECIFIC_SA_PARAM *specificSAParam, int *report)
{
  int a_i,e_i,agentPartIndex;
  HRI_AGENT * agent = NULL;
  HRI_ENTITY * entity1 = NULL; 
  HRI_ENTITY * entity2 = NULL; 

  HRI_KNOWLEDGE_ON_ENTITY * kn_on_ent;
  //HRI_VISIBILITY * vis_result; 
  ENUM_HRI_VISIBILITY_PLACEMENT res;
  double elevation, azimuth;
  HRI_REACHABILITY reachability_result;
  HRI_SPATIAL_RELATION spatial_relation_result; 
  HRI_PLACEMENT_RELATION placement_relation_result;

  HRI_VISIBILITY * vis_result;

  if(gEnv == NULL || gAgents==NULL) {
    *report = S_spark_NOT_INITIALIZED;
    return ETHER;
  }

  for(a_i=0; a_i<gAgents->all_agents_no; a_i++) {
    if(strcasestr(gAgents->all_agents[a_i]->robotPt->name, specificSAParam->agent.name)) {
      agent = gAgents->all_agents[a_i];
      break;
    }
  }
  if(agent == NULL) {
    *report = S_spark_AGENT_NOT_FOUND;
    return ETHER;
  }

  for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
    if (!strcmp(specificSAParam->entity1.name, gEntities->entities[e_i]->name)) {     
      entity1 = gEntities->entities[e_i];
      kn_on_ent = &agent->knowledge->entities[e_i];
      break;
    }
  } 
  if(entity1 == NULL) {
    *report = S_spark_OBJECT_NOT_FOUND;
    return ETHER;
  }


  /// Search for second entity only for processing type that needs it
  if(specificSAParam->updateControlType == SPARK_PLACEMENT_REL_PROC){
    for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
      if (!strcmp(specificSAParam->entity2.name, gEntities->entities[e_i]->name)) {      
	entity2 = gEntities->entities[e_i];
	break;
      }
    } 
    if(entity2 == NULL) {
      *report = S_spark_SECOND_OBJECT_NOT_FOUND;
      return ETHER;
    }    
  }
  
  if(specificSAParam->updateControlType == SPARK_REACH_PROC ){	  
    // TODO: Fix this global variable use. It's ugly. 
    GIK_VIS = 500;
    reachability_result = hri_is_reachable(entity1, agent);	    
    if ( kn_on_ent->reachability ==  reachability_result) {
      if ( kn_on_ent->reachability_ischanged)
	kn_on_ent->reachability_ischanged = FALSE;
    }
    else {
      kn_on_ent->reachability = reachability_result;
      kn_on_ent->reachability_ischanged = TRUE;
      kn_on_ent->reachability_isexported = FALSE;
    }
  }
  else if(specificSAParam->updateControlType == SPARK_LOOKAT_PROC){
    // LOOKS AT / VISIBILITY PLACEMENT - FOV,FOA,OOF
    // TODO: visibility placement for robot parts	
    if(entity1->disappeared)
      res = HRI_UK_VIS_PLACE;
    else
      hri_entity_visibility_placement(agent, entity1, true, kn_on_ent->is_placed_from_visibility, &res, &elevation, &azimuth);

    // need to update is_exported , is_changed?
    kn_on_ent->is_placed_from_visibility = (HRI_VISIBILITY_PLACEMENT) res;
    vis_result = MY_ALLOC(HRI_VISIBILITY,1);
    g3d_compute_visibility_for_given_entities(&entity1, agent, vis_result, 1); 
    if ( kn_on_ent->visibility  ==  vis_result[0]) {
      if ( kn_on_ent->visibility_ischanged)
	kn_on_ent->visibility_ischanged  = FALSE;
    }
    else {
      kn_on_ent->visibility = vis_result[0];
      kn_on_ent->visibility_ischanged = TRUE;
      kn_on_ent->visibility_isexported = FALSE;
    }      
    MY_FREE(vis_result,HRI_VISIBILITY,1);

    if ( (((HRI_VISIBILITY_PLACEMENT) res) == HRI_FOA) && (kn_on_ent->visibility  == HRI_VISIBLE)) {
      if (kn_on_ent->is_looked_at != HRI_TRUE_V){
	kn_on_ent->is_looked_at = HRI_TRUE_V;
	kn_on_ent->is_looked_at_ischanged = TRUE;
	kn_on_ent->is_looked_at_isexported = FALSE;
      }	      	      
    }
    else {
      if (kn_on_ent->is_looked_at == HRI_TRUE_V){
	kn_on_ent->is_looked_at_ischanged = TRUE;
	kn_on_ent->is_looked_at_isexported = FALSE;
      }	 
      if( (res == HRI_UK_VIS_PLACE) || (kn_on_ent->visibility  == HRI_UK_VIS))
	kn_on_ent->is_looked_at = HRI_UK_V;
      else
	kn_on_ent->is_looked_at = HRI_FALSE_V;
    }
    
  }
  else if(specificSAParam->updateControlType ==  SPARK_DELETE_DIVERGENT_POSITION){
    hri_delete_agent_entity_divergent_position(agent,e_i);
  }
  else if(specificSAParam->updateControlType ==  SPARK_FORCE_AGENT_KNOWS_POSITION){
    if(!kn_on_ent->hasEntityPositionKnowledge){	  
      kn_on_ent->hasEntityPositionKnowledge = true;
      agent->knowledge->numUnknownPositions--;
    }
  }
  else if(specificSAParam->updateControlType ==  SPARK_FORCE_AGENT_DOESNT_KNOW_POSITION){
    if(kn_on_ent->hasEntityPositionKnowledge){	  
      kn_on_ent->hasEntityPositionKnowledge = false;
      agent->knowledge->numUnknownPositions++;
      if(kn_on_ent->hasEntityPosition){
	kn_on_ent->hasEntityPosition = false;
	MY_FREE(kn_on_ent->entityPositionForAgent, double, kn_on_ent->entPt->robotPt->nb_dof);
	agent->knowledge->numDivergentPositions--;
      }
    }
  }
  else if((specificSAParam->updateControlType ==  SPARK_START_MANAGE_DISTANCE_INFO) || (specificSAParam->updateControlType ==  SPARK_STOP_MANAGE_DISTANCE_INFO)){
    agentPartIndex = specificSAParam->agentPartIndex;
    if((agentPartIndex < -1) || (agentPartIndex >= agent->hand_nb)){
      *report = S_spark_AGENT_PART_NOT_FOUND;
      return ETHER;
    }
    else{
      if(specificSAParam->updateControlType ==  SPARK_START_MANAGE_DISTANCE_INFO)
	hri_add_agent_entity_distance_management(agent,agentPartIndex,e_i);
      else
	hri_delete_agent_entity_distance_management(agent,agentPartIndex,e_i);
    }
  }
  else{
    *report = S_spark_UNMANAGED_TYPE;
    return ETHER;
  }


  *report = OK;
  return ETHER;
}

/* sparkUpdateAllSAMain  -  codel EXEC of UpdateAllSituationAssessment
   this function will force or inhibit the update of situation assessement
*/
// request used to force reprocessing, to print value or update some parameters values, ...
ACTIVITY_EVENT
sparkUpdateAllSAMain( SPARK_SA_UPDATE_PARAM *updateAllSAParam, int *report)
{
  if(gEntities == NULL) {
    *report = S_spark_NOT_INITIALIZED;
    return ETHER;
  }
  if( updateAllSAParam->type == SPARK_UPDATE_ALL){
    gEntities->needSituationAssessmentUpdate = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_LOOK_AT){
    gEntities->needLooksatUpdate = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_BLOCK_UPDATE_ALL){
    gEntities->isWorldStatic = FALSE;
    gEntities->forbidWorldStatic = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_DEBLOCK_UPDATE_ALL){
    gEntities->forbidWorldStatic = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_ALL_UPDATE){
    SDI_F->state.oroPrintEnabled = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_NOPRINT_ALL_UPDATE){
    SDI_F->state.oroPrintEnabled = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_ALL_SPARK_ORO){
#ifdef ORO 
    printAllOroFacts(gAgents, gEntities); 
#if defined(USE_MIGHTABILITY_MAPS)
    printAgentsActivityFactsForORO(gAgents,HUMAN1_MA);
#endif
#endif
  }
  else if( updateAllSAParam->type == SPARK_REEXPORT_ALL_SPARK_ORO){
#ifdef ORO 
    clearFacts(); 
    reinitFactsForOROExportControl(gAgents, gEntities); 
    prepareFactsForORO(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
    reinitAgentsActivityFactsForOROExportControl(gAgents,HUMAN1_MA);
    prepareAgentsActivityFactsForORO(gAgents,Ag_Activity_Fact,HUMAN1_MA);
#endif
    sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
#endif
  }
  else if( updateAllSAParam->type == SPARK_CREATE_VISIBILITY_IMAGES_ON){
    gEntities->printVisibilityImages = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_CREATE_VISIBILITY_IMAGES_OFF){
    gEntities->printVisibilityImages = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_ALLOW_DISAPPEAR){
    gEntities->general_allow_disappear = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_FOREBID_DISAPPEAR){
    gEntities->general_allow_disappear = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_VIMAN_INPUT){
    SDI_F->state.vimanPrintEnabled = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_NOPRINT_VIMAN_INPUT){
    SDI_F->state.vimanPrintEnabled = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_REACHABILITY_DISTANCE){    
    gEntities->needToUpdateParameters = TRUE;   
    gEntities->numParameterToUpdate = 0;
    gEntities->hackedReachabilityDistance = updateAllSAParam->doubleUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_NOT_STATIC_WITHOUT_RECOMPUTATION_ITER_MAX){ 
    gEntities->maxWorldNotStaticBeforeRecompute = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_NO_EVENT_STEPS_BEFORE_STATIC_ITER_MIN){ 
    gEntities->lastEventsInTheWorldStepsMin = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_DISAPEAR_ITER_MAX){
    gEntities->needToUpdateParameters = TRUE;   
    gEntities->numParameterToUpdate = 1;
    gEntities->maxUnexplainedUndetectionIter = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_IS_ON_MAX_DIST){    
    gEntities->needToUpdateParameters = TRUE;
    gEntities->numParameterToUpdate = 2;
    gEntities->isOnThreshold = updateAllSAParam->doubleUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_AVERAGE_MOTION_EXPORT_THRESHOLD){    
    gEntities->averageDistanceScoreExportThreshold = updateAllSAParam->doubleUpdatedValue;
  }

  else if( updateAllSAParam->type == SPARK_SWITCH_PRINT_SA_RECOMPUTE_STATUS){ 
    if(gEntities->printSARecomputeStatus) {
      gEntities->printSARecomputeStatus=FALSE;
      printf("stop printing SA status\n");   
    }
    else{
      gEntities->printSARecomputeStatus=TRUE;
      printf("start printing SA status\n");   
    }
  }
  else if( updateAllSAParam->type == SPARK_SWITCH_DISPLAY_SA_RECOMPUTE_STATUS){ 
    if(gEntities->displaySARecomputeStatus) {
      gEntities->displaySARecomputeStatus=false;
      printf("stop displaying SA status\n");   
    }
    else{
      gEntities->displaySARecomputeStatus=true;
      printf("start displaying SA status\n");   
    }
  }
  else if( updateAllSAParam->type == SPARK_SWITCH_DRAW_ACTION_MONITORING_SPHERES){ 
    if(gSpheres->drawSpheres){
      printf("stop drawing monitoring spheres\n"); 
      gSpheres->drawSpheres = FALSE;
    }
    else{
      printf("start drawing monitoring spheres\n"); 
      gSpheres->drawSpheres = TRUE; 
      gSpheres->drawSpheresOpacity = updateAllSAParam->doubleUpdatedValue;
    }
  }
  else if( updateAllSAParam->type == SPARK_ENABLE_DIVERGENT_POSITION){
    gEntities->manageDivergentBeliefs = true;
  }
  else if( updateAllSAParam->type == SPARK_DISABLE_DIVERGENT_POSITION){
    gEntities->manageDivergentBeliefs = false;
  }  
  else if( updateAllSAParam->type == SPARK_START_SEND_LOOK_DIRECTION_ORO_FACTS){
    SDI_F->state.inhibitLookDirectionOroFactsSending = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_STOP_SEND_LOOK_DIRECTION_ORO_FACTS){
    SDI_F->state.inhibitLookDirectionOroFactsSending = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_LOOPING_REQUEST_TIME){
    if(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled){
      printf("stop printing loop request time\n"); 
      SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled = FALSE;
    }
    else{
      printf("start printing loop request time\n"); 
      SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled = TRUE; 
    }
  }
  else if( updateAllSAParam->type == SPARK_PRINT_LOOPING_REQUEST_TIME_ITER){ 
    SDI_F->requestTimeInfo.printLoopRequestExecutionTimePrintPeriod = updateAllSAParam->intUpdatedValue;
    printf("printing loop request time iter is %d\n",SDI_F->requestTimeInfo.printLoopRequestExecutionTimePrintPeriod);
  }
  else if( updateAllSAParam->type == SPARK_FORCE_REACHABILITY_REEXPORT_TO_ORO){
    SDI_F->state.reexportReachabilityFactsToOro = TRUE;
  }
  else {
    *report = S_spark_UNKNOWN_UPDATE_TYPE;
    return ETHER;
  }
  

  *report = OK;
  return ETHER;
}

void setAgActivtitySituationAssessmentUpdateNeeds(int for_agent)
{

#if defined(USE_MIGHTABILITY_MAPS)
  printf(" ========= Status for agent %s =======\n",gEnv->robot[Ag_Activity_Fact[HUMAN1_MA].agent_index]->name);

  printf(" Whole Body : %d \n",Ag_Activity_Fact[for_agent].whole_body);
  printf(" Torso: %d \n",Ag_Activity_Fact[for_agent].torso);
  printf(" Head: %d \n",Ag_Activity_Fact[for_agent].head);
    
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand);
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand_mode);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand_mode); 
#endif
}

int decideSituationAssessmentAgentRelatedUpdate(int agentIndex){
  int eventsInTheWorld = FALSE;
  int needSituationAssessmentUpdate = FALSE;
  int needLooksatUpdate = FALSE;
  
  ///Whole Body and Torso and hand move (in manipulation mode) require to recompute ALL

  ///Head Move require to recompute only look at

  ///All other move than head imply eventsInTheWorld FALSE.

#if defined(USE_MIGHTABILITY_MAPS)
  if((Ag_Activity_Fact[agentIndex].whole_body == AGENT_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].whole_body == AGENT_MOVING) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
    //printf("Agent %d moving %d \n",agentIndex,Ag_Activity_Fact[agentIndex].whole_body);
  }

  if((Ag_Activity_Fact[agentIndex].torso == AGENT_TORSO_HAS_TURNED) || (Ag_Activity_Fact[agentIndex].torso == AGENT_TORSO_TURNING) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if(((Ag_Activity_Fact[agentIndex].right_hand == AGENT_HAND_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].right_hand == AGENT_HAND_MOVING)) && (Ag_Activity_Fact[agentIndex].right_hand_mode == AGENT_HAND_AT_MANIPULATION_MODE) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if(((Ag_Activity_Fact[agentIndex].left_hand == AGENT_HAND_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].left_hand == AGENT_HAND_MOVING)) && (Ag_Activity_Fact[agentIndex].left_hand_mode == AGENT_HAND_AT_MANIPULATION_MODE) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if((Ag_Activity_Fact[agentIndex].head == AGENT_HEAD_HAS_TURNED) || (Ag_Activity_Fact[agentIndex].head == AGENT_HEAD_TURNING) ){
    needLooksatUpdate = TRUE;
  }
#endif
  if(eventsInTheWorld)
    gEntities->eventsInTheWorld = TRUE;
  if(needSituationAssessmentUpdate)
    gEntities->needSituationAssessmentUpdate = TRUE;
  if(needLooksatUpdate)
    gEntities->needLooksatUpdate = TRUE;

  return TRUE;
} 


int feedVisReachVisualisationStruct(int agentIndex){
  int a_i,e_i,agent_index;

#if defined(USE_MIGHTABILITY_MAPS)

  if(gAgents == NULL || gEnv == NULL || gEntities == NULL) {
    return FALSE;
  }  
  
  if (SHOW_OBJECT_FACTS == 1){
    for(a_i=0; a_i<gAgents->all_agents_no; a_i++) {
      agent_index = Ag_Activity_Fact[agentIndex].agent_index;
      if( agent_index >= 0){
	if( strcasestr(gAgents->all_agents[a_i]->robotPt->name,gEnv->robot[agent_index]->name)){
	  for(int e_i=0; e_i<gEntities->entities_nb; e_i++) {
	    if((gEntities->entities[e_i]->subtype == HRI_MOVABLE_OBJECT) && gEntities->entities[e_i]->is_present){
	  
	      if (gAgents->all_agents[a_i]->knowledge->entities[e_i].visibility == HRI_VISIBLE)
		OBJ_IS_VISIBLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex]= 1;
	      else
		OBJ_IS_VISIBLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex]= 0;

	      if (gAgents->all_agents[a_i]->knowledge->entities[e_i].reachability == HRI_REACHABLE)
		OBJ_IS_REACHABLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex][0]= 1;	
	      else
		OBJ_IS_REACHABLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex][0]= 0;	
	    }
	  }
	  break;
	}      
      }
    }
  }

#endif
  
  return TRUE;
} 


/* sparkComputeFactsStart  -  codel START of ComputeFacts
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsStart(int *report)
{  
  return EXEC;
}


/* sparkComputeFactsMain  -  codel EXEC of ComputeFacts
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsMain(int *report)
{ 
  if (gAgents == NULL) return EXEC;
  
  float clock_val = 0;
  float elapsed_time = 0;

  /// time assessment
  double timeStart;
  getRequestTimeStart(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart);

  //clock_val = clock();
#if defined(USE_MIGHTABILITY_MAPS)
  decideSituationAssessmentAgentRelatedUpdate(HUMAN1_MA);
  //ASA do not work for robot
  // #if defined(JIDO)
  //   decideSituationAssessmentAgentRelatedUpdate(JIDO_MA);
  // #endif
  // #if defined(PR2)
  //   decideSituationAssessmentAgentRelatedUpdate(PR2_MA);
  // #endif
#endif

  hri_manage_object_disappearance_and_move(gAgents, gEntities,gAgents->source_agent_idx );
  hri_compute_geometric_facts(gAgents, gEntities,gAgents->source_agent_idx);
#if defined(USE_MIGHTABILITY_MAPS)
  feedVisReachVisualisationStruct(HUMAN1_MA);
  //feedVisReachVisualisationStruct(JIDO_MA);
#endif
#ifdef ORO
  clearFacts(); 
  prepareFactsForORO(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
  prepareAgentsActivityFactsForORO(gAgents,Ag_Activity_Fact,HUMAN1_MA);
#endif
  sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
#endif
  
  //elapsed_time = (clock() - clock_val)/CLOCKS_PER_SEC;
  //printf("TIME passed for: %f overall,\n", elapsed_time);
  //Get End Time if needed
  trackRequestTime(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart,SDI_F->requestTimeInfo.printLoopRequestExecutionTimeComputeFactsIndex);

  return EXEC;
}


/* sparkComputeFactsEnd  -  codel END of ComputeFacts
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsEnd(int *report)
{
  return ETHER;
}


/* sparkComputeFactsInter  -  codel INTER of ComputeFacts
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsInter(int *report)
{
  return ETHER;
}

/* ------------------------------------------------------------- */
/* ---------  Manage Spheres Monitor Poster  ------------------- */
/* ------------------------------------------------------------- */

void publishSpheresMonitorPoster( void )
{ 
  sparkMonitoringSpheresmonitoringSpheresPosterWrite(SPARK_MONITORINGSPHERES_POSTER_ID, &SDI_F->monitoringSpheres);
}

static int updateSpheresMonitorPoster( void )
{
  int i;
  int iterModif = 0;
  if(gSpheres->modifIndex != SDI_F->monitoringSpheres.modifIndex){
    SDI_F->monitoringSpheres.modifIndex = gSpheres->modifIndex;
    //Reinit all spheres modifIndex if > 100
    if(gSpheres->modifIndex > 100)
      gSpheres->modifIndex = 0;

    for(i=0; i<SPARK_NUM_SPHERES_MAX; i++) {
      if(gSpheres->spheres[i]->modifIndex != SDI_F->monitoringSpheres.spheres[i].modifIndex){
	//Reinit sphere modifIndex if > 100
	if(gSpheres->spheres[i]->modifIndex > 100)
	  gSpheres->spheres[i]->modifIndex = 0;
	iterModif++;
	SDI_F->monitoringSpheres.spheres[i].modifIndex = gSpheres->spheres[i]->modifIndex;

	SDI_F->monitoringSpheres.spheres[i].isSphereActive = gSpheres->spheres[i]->isSphereActive;
	strcpy(SDI_F->monitoringSpheres.spheres[i].agentName.name, gSpheres->spheres[i]->agentName);
	SDI_F->monitoringSpheres.spheres[i].agentIndex = gSpheres->spheres[i]->agentIndex;
	strcpy(SDI_F->monitoringSpheres.spheres[i].objectName.name, gSpheres->spheres[i]->objectName);

	SDI_F->monitoringSpheres.spheres[i].entityIndex = gSpheres->spheres[i]->entityIndex;
	SDI_F->monitoringSpheres.spheres[i].handIndexInput = gSpheres->spheres[i]->handIndexInput;
	SDI_F->monitoringSpheres.spheres[i].sphereCenter.x = gSpheres->spheres[i]->sphereCenterX;
	SDI_F->monitoringSpheres.spheres[i].sphereCenter.y = gSpheres->spheres[i]->sphereCenterY;
	SDI_F->monitoringSpheres.spheres[i].sphereCenter.z = gSpheres->spheres[i]->sphereCenterZ;
	SDI_F->monitoringSpheres.spheres[i].sphereRadius = gSpheres->spheres[i]->sphereRadius;
	SDI_F->monitoringSpheres.spheres[i].sphereType = (SPARK_SPHERE_TYPE) gSpheres->spheres[i]->sphereType;
	SDI_F->monitoringSpheres.spheres[i].monitorEnterInResult = gSpheres->spheres[i]->monitorEnterInResult;
	SDI_F->monitoringSpheres.spheres[i].monitorGetOutResult = gSpheres->spheres[i]->monitorGetOutResult;
	SDI_F->monitoringSpheres.spheres[i].handIndexResult = gSpheres->spheres[i]->handIndexResult;
	SDI_F->monitoringSpheres.spheres[i].filteringTimeThreshold = gSpheres->spheres[i]->filteringTimeThreshold;
      }
    }
  }
  if(iterModif > 0)
    publishSpheresMonitorPoster();

  return TRUE;  
}

/* ------------------------------------------------------------- */
/* ----------------------- Test Sphere Monitors ---------------- */
/* ------------------------------------------------------------- */

ACTIVITY_EVENT
sparkTestSphereMonitorStart(int *report)
{
  if(!initSpheresIsDone){  
    gSpheres = hri_create_spheres(SPARK_NUM_SPHERES_MAX);   
    initSpheresIsDone = true;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkTestSphereMonitorMain(int *report)
{
  /// time assessment
  double timeStart;
  getRequestTimeStart(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart);

  hriTestMonitor(gAgents, gEntities,gSpheres,SPARK_NUM_SPHERES_MAX,0);
  updateSpheresMonitorPoster();

  trackRequestTime(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart,SDI_F->requestTimeInfo.printLoopRequestExecutionTimeTestSpheresIndex);

  return EXEC;
}

/* ------------------------------------------------------------- */
/* ----------------------- Update Sphere Monitors -------------- */
/* ------------------------------------------------------------- */

ACTIVITY_EVENT
sparkUpdateSphereMonitorStart(SPARK_ACTION_MONITORING_SPHERE_INPUT_PARAMS *monitoringSphereInput,int *report)
{
  if(!initSpheresIsDone){  
    gSpheres = hri_create_spheres(SPARK_NUM_SPHERES_MAX);   
    initSpheresIsDone = true;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkUpdateSphereMonitorMain(SPARK_ACTION_MONITORING_SPHERE_INPUT_PARAMS *monitoringSphereInput, int *report)
{
  int e_j,a_i;

  if(monitoringSphereInput->monitorIndex >= SPARK_NUM_SPHERES_MAX){
    *report = S_spark_SPHERE_INDEX_TOO_BIG;
    return ETHER;
  }

  // Get Object index in entity array
  for(e_j=0; e_j<gEntities->entities_nb; e_j++) {
    if (!strcmp(monitoringSphereInput->objectName.name, gEntities->entities[e_j]->robotPt->name)){
      break;
    }
  }  
  if( e_j == gEntities->entities_nb) {
    *report = S_spark_OBJECT_NOT_FOUND;
    return ETHER;
  }

  
  // Get Agent index in agent array 
  for(a_i=0; a_i<gAgents->all_agents_no; a_i++){
    if (!strcmp(monitoringSphereInput->agentName.name, gAgents->all_agents[a_i]->robotPt->name)){  	  break;
    }
  }    

  if(a_i == gAgents->all_agents_no){
    *report = S_spark_AGENT_NOT_FOUND;
    return ETHER;
  }

  if(monitoringSphereInput->handIndexInput >= gAgents->all_agents[a_i]->hand_nb){
    *report = S_spark_AGENT_HAND_INDEX_TOO_BIG;
    return ETHER;
  }  

  hriUpdateSphereInSpheres(gAgents, gEntities, gSpheres ,SPARK_NUM_SPHERES_MAX, monitoringSphereInput->monitorIndex, monitoringSphereInput->activateSphere, monitoringSphereInput->agentName.name, a_i, monitoringSphereInput->objectName.name,e_j, monitoringSphereInput->sphereCenter.x,monitoringSphereInput->sphereCenter.y,monitoringSphereInput->sphereCenter.z , monitoringSphereInput->sphereRadius, monitoringSphereInput->sphereRadiusMultiply, monitoringSphereInput->sphereCenterTranslationMultiply , monitoringSphereInput->filteringTimeThreshold, (HRI_SPHERE_TYPE) monitoringSphereInput->sphereType);
  return ETHER;
}


/* ------------------------------------------------------------- */
/* ---------  Manage Distance Poster  ------------------- */
/* ------------------------------------------------------------- */

void publishDistancesInfoPoster( void )
{ 
  sparkDistancesInfodistancesInfoPosterWrite(SPARK_DISTANCESINFO_POSTER_ID, &SDI_F->distancesInfo);
}

void createVec(double x,double y, double z,SPARK_3D_COORD & newVec){
  newVec.x =x;
  newVec.y =y;
  newVec.z =z;
}

void copyVec(SPARK_3D_COORD vec,SPARK_3D_COORD & newVec){
  newVec.x =vec.x;
  newVec.y =vec.y;
  newVec.z =vec.z;
}

void getVecABFromPointAAndPointB(SPARK_3D_COORD pointA,SPARK_3D_COORD pointB,SPARK_3D_COORD & vecAB){
  vecAB.x = pointB.x - pointA.x;
  vecAB.y = pointB.y - pointA.y;
  vecAB.z = pointB.z - pointA.z;
}

void getPointBFromPointAAndVecAB(SPARK_3D_COORD pointA,SPARK_3D_COORD vecAB,SPARK_3D_COORD & pointB){
  pointB.x = vecAB.x + pointA.x;
  pointB.y = vecAB.y + pointA.y;
  pointB.z = vecAB.z + pointA.z;
}

void getMultVec(SPARK_3D_COORD & vec,double mult){
  vec.x = vec.x*mult;
  vec.y = vec.y*mult;
  vec.z = vec.z*mult;
}

void getVecsSum(SPARK_3D_COORD vec1,SPARK_3D_COORD vec2,SPARK_3D_COORD & vecSum){
  vecSum.x = vec1.x + vec2.x;
  vecSum.y = vec1.y + vec2.y;
  vecSum.z = vec1.z + vec2.z;
}

void getVecProd(SPARK_3D_COORD vec1,SPARK_3D_COORD vec2,SPARK_3D_COORD & vecProd){
  vecProd.x = vec1.y*vec2.z - vec1.z*vec2.y;
  vecProd.y = vec1.z*vec2.x - vec1.x*vec2.z;
  vecProd.z = vec1.x*vec2.y - vec1.y*vec2.x;
}

bool getIntersectionWithHorizontalPlan(SPARK_3D_COORD startPoint,SPARK_3D_COORD directionVec,double planHeight,SPARK_3D_COORD &planInterPoint){
  if((directionVec.z != 0.0) || (startPoint.z == planHeight)){
    if((directionVec.z == 0.0) &&  (startPoint.z == planHeight)){
      getPointBFromPointAAndVecAB(startPoint,directionVec,planInterPoint);
      return true;
    }
    else{
      planInterPoint.x = (planHeight - startPoint.z)*directionVec.x/directionVec.z + startPoint.x;
      planInterPoint.y = (planHeight - startPoint.z)*directionVec.y/directionVec.z + startPoint.y;
      planInterPoint.z = planHeight;
      return true;
    }
  }
  else
    return false;
}

double getVecScalProd(SPARK_3D_COORD vec1,SPARK_3D_COORD vec2){
  return vec1.x*vec2.x+vec1.y*vec2.y+vec1.z*vec2.z;
}

void getVecProdVecOnPlanZ0(SPARK_3D_COORD vec1,SPARK_3D_COORD vec2,SPARK_3D_COORD & vecProd){
  vecProd.x = -vec1.z*vec2.y;
  vecProd.y = vec1.z*vec2.x;
  vecProd.z = vec1.x*vec2.y - vec1.y*vec2.x;
}


double getVecDistance(SPARK_3D_COORD vec){
  return D3D(0,0,0,vec.x,vec.y,vec.z);
}

double getDistanceBetweenPoints(SPARK_3D_COORD point1,SPARK_3D_COORD point2){
  return D3D(point1.x,point1.y,point1.z,point2.x,point2.y,point2.z);
}

double get2DDistanceBetweenPoints(SPARK_3D_COORD point1,SPARK_3D_COORD point2){
  return D2D(point1.x,point1.y,point2.x,point2.y);
}

void getPointAtAlphaFromVecAB(double alpha,SPARK_3D_COORD pointA,SPARK_3D_COORD pointB,SPARK_3D_COORD &pointAlphaAB){
  pointAlphaAB.x = alpha*pointB.x +  (1-alpha)*pointA.x;
  pointAlphaAB.y = alpha*pointB.y + (1-alpha)*pointA.y;
  pointAlphaAB.z = alpha*pointB.z + (1-alpha)*pointA.z;
}


void normalizeVec(SPARK_3D_COORD & vec){
  getMultVec(vec,1/getVecDistance(vec));
}

void printVec(SPARK_3D_COORD & vec,int printInt){
  printf("Print num %d of vector : x : %f ; y : %f ; z : %f\n",printInt,vec.x,vec.y,vec.z);
}

bool needToUpdateTableCorners(int entityIndex,SPARK_3D_COORD corners[],double threshold){
  SPARK_BB_POINTS bbPoints;
  bool cornerUsed[4] = {false,false,false,false};
  double dist,minDist = 0;
  int minDistIndex = 0;
  double totalDist = 0;
  bool minDistInitialized;

  //we get min distance between a new corner and an old corner
  if(getBBPoints( gEntities->entities[entityIndex]->robotPt,&bbPoints)){
    //update table corners
    for(int i = 0; i < 4 ; i++){
      //find first corner not already used
      minDistInitialized = false;
      for(int j = 0; j < 4 ; j++){
	if(!cornerUsed[j] && !minDistInitialized){
	  minDist = get2DDistanceBetweenPoints(bbPoints.bbPointsTable[i],corners[j]);
	  minDistIndex = j;
	  minDistInitialized = true;
	}
	if(!cornerUsed[j] && minDistInitialized && (minDistIndex < j)){
	  dist = get2DDistanceBetweenPoints(bbPoints.bbPointsTable[i],corners[j]);
	  if(dist<minDist){
	    minDist = dist;
	    minDistIndex = j;
	  }
	}
      }
      //closest old corner from new corner i is corner with index minDistIndex  (not alread used as closest from previous corner)
      cornerUsed[minDistIndex] = true;
      totalDist += minDist; 
    }
    totalDist = totalDist/4;
    if(totalDist>threshold){
      printf("Table corner points change score is %f. More than %f --> table update\n",totalDist,threshold);
      return true;
    }
    else
      return false;
  }
  else 
    return true;
}

bool UpdateTablePointsInDistanceManagement(int entityIndex,int tableIndex){
  // For table points management
  //getBBPoints give 8 points of BB. 3 four points are on the uper horizontal plane. 
  //point 0 - point 1 is the side 1 , point 0 - point 2 is the side 2 these are not the diagonal.
  SPARK_BB_POINTS bbPoints;
  SPARK_3D_COORD table0; // first table point in BB table
  SPARK_3D_COORD table1; // second table point in BB table -> side1
  SPARK_3D_COORD table2; // third table point in BB table -> side2
  SPARK_3D_COORD pointStart;
  SPARK_3D_COORD newPoint;
  SPARK_3D_COORD vec1; //normalized vector along side 1
  SPARK_3D_COORD vec2;
  SPARK_3D_COORD vecTrans1; //normalized vector along side 1
  SPARK_3D_COORD vecTrans2;
  SPARK_3D_COORD vecTrans;

  double distSide1; //side1
  double distSide2; //side2
  int numPointsSide1;
  int numPointsSide2;
  double tableStep;
  int iter = 0;
  int numTablesPoints =  SDI_F->distancesInfo.numTablePoints;

  if(getBBPoints( gEntities->entities[entityIndex]->robotPt,&bbPoints)){

    //update table corners
    for(int i = 0; i < 4 ; i++)
      copyVec(bbPoints.bbPointsTable[i],SDI_F->distancesInfo.tables[tableIndex].tableCornersPositions[i]);
	
    tableStep = SDI_F->distancesInfo.tableStep;
    distSide1=bbPoints.side1Length; //side1
    distSide2=bbPoints.side2Length; //side2
    numPointsSide1 = floor(distSide1/tableStep); 
    numPointsSide2 = floor(distSide2/tableStep);

    copyVec(bbPoints.bbPointsTable[0],table0);
    copyVec(bbPoints.bbPointsTable[1],table1);
    copyVec(bbPoints.bbPointsTable[2],table2);
      
    getVecABFromPointAAndPointB(table0,table1,vec1);
    normalizeVec(vec1);
    getVecABFromPointAAndPointB(table0,table2,vec2);
    normalizeVec(vec2);

    copyVec(vec1,vecTrans1);
    getMultVec(vecTrans1,(distSide1-numPointsSide1*tableStep)/2);
    copyVec(vec2,vecTrans2);	  
    getMultVec(vecTrans2,(distSide2-numPointsSide2*tableStep)/2);

    getVecsSum(vecTrans1,vecTrans2,vecTrans);
    getPointBFromPointAAndVecAB(table0,vecTrans,pointStart);
      
    for(int i = 0; i <= numPointsSide1 ; i++){
      for(int j = 0; j <= numPointsSide2 ; j++){
	if( numTablesPoints ==  SDI_F->distancesInfo.numTablePointsMax ){
	  printf("Too many table points in distances info poster. Max is %d\n",SDI_F->distancesInfo.numTablePointsMax);
	  return false;
	}
	else{ 
	  if(SDI_F->distancesInfo.tables[tableIndex].firstTablePointIndex == -1)
	    SDI_F->distancesInfo.tables[tableIndex].firstTablePointIndex = numTablesPoints;
	  copyVec(vec1,vecTrans1);
	  getMultVec(vecTrans1,i*tableStep);
	  copyVec(vec2,vecTrans2);	  
	  getMultVec(vecTrans2,j*tableStep);

	  getVecsSum(vecTrans1,vecTrans2,vecTrans);
	  getPointBFromPointAAndVecAB(pointStart,vecTrans,newPoint);
	  //printVec(newPoint,6+i*numPointsSide1+j);
	    
	  SDI_F->distancesInfo.tablePoints[numTablesPoints].mainEntityIndex = entityIndex;
	  SDI_F->distancesInfo.tablePoints[numTablesPoints].entityIndex = -1;
	  SDI_F->distancesInfo.tablePoints[numTablesPoints].mainEntityFamillyIndex = iter;

	  copyVec(newPoint,SDI_F->distancesInfo.tablePoints[numTablesPoints].position);

	  numTablesPoints++;
	  iter++;
	}
      }
    }
    SDI_F->distancesInfo.numTablePoints = numTablesPoints;
      
    if(SDI_F->distancesInfo.tables[tableIndex].firstTablePointIndex != -1)
      SDI_F->distancesInfo.tables[tableIndex].numTablePoints = numTablesPoints - SDI_F->distancesInfo.tables[tableIndex].firstTablePointIndex;
    return true;
  }
  else 
    return false;	
}


// void updateAngles( void ){
//   //get robot direction vector
//   //POM_EULER *jointAbsPose;
//   int someIter = 0;
//   int numPositions = SDI_F->distancesInfo.numPositions;
//   double angle = 0.0;
//   SPARK_3D_COORD uX; // 
//   SPARK_3D_COORD uY; // 
//   SPARK_3D_COORD uRobot; // 
//   SPARK_3D_COORD uRobotToObject; 
//   SPARK_3D_COORD robotPoint;
//   SPARK_3D_COORD vecProd;

//   p3d_jnt* jnt;
//   jnt = p3d_get_robot_jnt_by_name( gRobot->robotPt, "platformJoint");
//   T3D* jointToOrigin = t3dNew( T3D_MATRIX, T3D_ALLOW_CONVERSION );
//   for(unsigned int i=0; i<4; i++) {
//     for(unsigned int j=0; j<4; j++) {
//       jointToOrigin->matrix[4*i+j] = jnt->abs_pos[i][j];
//       }
//    }
//   t3dConvertTo( T3D_BRYAN, jointToOrigin );
//   double robotYaw = jointToOrigin->euler.yaw;
//   robotPoint.x = jointToOrigin->euler.x;
//   robotPoint.y = jointToOrigin->euler.y;
//   robotPoint.z = 0;

//   //
//   uX.x=cos(robotYaw);
//   uX.y=0;
//   uX.z=0;

//   uY.x=0;
//   uY.y=sin(robotYaw);
//   uY.z=0;

//   SPARK_3D_COORD vecTrans;
//   getVecsSum(uX,uY,uRobot);

//   someIter = 0;
//   for(int i = 0; i< numPositions; i++){
//     if( someIter == SPARK_DISTANCES_INFO_NUM_ANGLES_MAX){
//       printf("Too many angles in distances info poster. Max is %d\n",SPARK_DISTANCES_INFO_NUM_ANGLES_MAX);
//       return;
//     }
//     getVecABFromPointAAndPointB(robotPoint,SDI_F->distancesInfo.positions[i].elemPosition,uRobotToObject);
//     uRobotToObject.z = 0;
//     normalizeVec(uRobotToObject);
//     getVecProd(uRobot,uRobotToObject,vecProd);
//     angle = asin(vecProd.z);
//     SDI_F->distancesInfo.angles[someIter].indexElem1 = -1;
//     SDI_F->distancesInfo.angles[someIter].indexElem2 = i;
//     SDI_F->distancesInfo.angles[someIter].angle = angle; 
//     someIter++;
//   }
//   SDI_F->distancesInfo.numAngles = someIter;
// }


// void deleteEntityInDistanceManagement(int entityIndex){
//   //delete all positions related to this entity
//   int offSetIndex = 0;
//   int numPositions = SDI_F->distancesInfo.numPositions;
//   for(int i = 0; i< numPositions; i++){
//     if(SDI_F->distancesInfo.positions[i].mainEntityIndex == entityIndex){
//       if(SDI_F->distancesInfo.positions[i].elemType == SPARK_DIST_SIMPLE_OBJECT)
// 	SDI_F->distancesInfo.numSimpleObjects--;
//       else if (SDI_F->distancesInfo.positions[i].elemType == SPARK_DIST_SUPPORT_POINT)
// 	SDI_F->distancesInfo.numSupportPoints--;
//       offSetIndex++;
//     }
//     else{
//       if ( offSetIndex > 0){
// 	SDI_F->distancesInfo.positions[i-offSetIndex].mainEntityIndex = SDI_F->distancesInfo.positions[i].mainEntityIndex;
// 	SDI_F->distancesInfo.positions[i-offSetIndex].entityIndex = SDI_F->distancesInfo.positions[i].entityIndex;
// 	SDI_F->distancesInfo.positions[i-offSetIndex].mainEntityFamillyIndex = SDI_F->distancesInfo.positions[i].mainEntityFamillyIndex;
// 	SDI_F->distancesInfo.positions[i-offSetIndex].elemType = SDI_F->distancesInfo.positions[i].elemType;
// 	//position will be udpated.
// 	// SDI_F->distancesInfo.positions[i-offSetIndex].mainEntityIndex = SDI_F->distancesInfo.positions[i].mainEntityIndex;
//       }
//     }
//   } 
//   // if(SDI_F->distancesInfo.numSupportPoints < 0)
//   //   SDI_F->distancesInfo.numSupportPoints = 0;

//   SDI_F->distancesInfo.numPositions = numPositions-offSetIndex;
// }


bool addAgentEntity(int entityIndex,int modifyParameterCommand , double doubleParameterValue,  int intParameterValue, GEN_STRING64  baseJointName,GEN_STRING64  shoulderJointName0,GEN_STRING64  shoulderJointName1){
  if(SDI_F->distancesInfo.numAgents == SDI_F->distancesInfo.numAgentsMax){
    printf("Too many agentts for distance management. Max is %d\n",SDI_F->distancesInfo.numAgentsMax);
    return false;
  }
  int e_i,a_i,h_i,curIndex,numHandsInDistManagementStart,numHeadsInDistManagementStart;
  int curAgentIndex = SDI_F->distancesInfo.numAgents;  
  SDI_F->distancesInfo.agents[curAgentIndex].entityIndex = entityIndex; 
  strcpy(SDI_F->distancesInfo.agents[curAgentIndex].entityName.name,gEntities->entities[entityIndex]->robotPt->name);
  strcpy(SDI_F->distancesInfo.agents[curAgentIndex].baseJointName.name,baseJointName.name);

  SDI_F->distancesInfo.agents[curAgentIndex].allowPointingComputation = FALSE;
  SDI_F->distancesInfo.agents[curAgentIndex].allowGestureComputation = FALSE;
  SDI_F->distancesInfo.agents[curAgentIndex].allowAngleComputation = TRUE;
  

  //find which agent it is.
  //for all agent hand find which entity index it is.
  for(a_i=0; a_i<gAgents->all_agents_no; a_i++){
    if (!strcmp(gEntities->entities[entityIndex]->robotPt->name, gAgents->all_agents[a_i]->robotPt->name)){ 
      numHandsInDistManagementStart = SDI_F->distancesInfo.numHands;
      SDI_F->distancesInfo.agents[curAgentIndex].firstHandIndex = -1;
      for(h_i=0; h_i<gAgents->all_agents[a_i]->hand_nb; h_i++){
	//is there still place for a new hand and arm
	if(SDI_F->distancesInfo.numHands == SDI_F->distancesInfo.numHandsMax)
	  printf("Too many hands for distance management. num hands is %d max is %d.\n",SDI_F->distancesInfo.numHands,SDI_F->distancesInfo.numHandsMax);
	else{
	  if(h_i>1)
	    printf("We expect as much two hands for agent\n");
	  else{
	    //get hand entity	  
	    for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
	      if (gAgents->all_agents[a_i]->hand[h_i] == gEntities->entities[e_i]){
		curIndex = SDI_F->distancesInfo.numHands;
		//add hand
		if(numHandsInDistManagementStart == curIndex)
		  SDI_F->distancesInfo.agents[curAgentIndex].firstHandIndex = curIndex;
		SDI_F->distancesInfo.hands[curIndex].mainEntityIndex = entityIndex;
		SDI_F->distancesInfo.hands[curIndex].entityIndex = e_i;
		SDI_F->distancesInfo.hands[curIndex].mainEntityFamillyIndex = curIndex-numHandsInDistManagementStart;
	      
		//add arm
		SDI_F->distancesInfo.arms[curIndex].agentEntityIndex = entityIndex;
		SDI_F->distancesInfo.arms[curIndex].mainEntityFamillyIndex = curIndex-numHandsInDistManagementStart;
		if(h_i == 0)
		  strcpy(SDI_F->distancesInfo.arms[curIndex].shoulderJointName.name,shoulderJointName0.name);
		else if(h_i == 1) 
		  strcpy(SDI_F->distancesInfo.arms[curIndex].shoulderJointName.name,shoulderJointName1.name);
		else
		  printf("We expect not more than two hands for agent\n");

		SDI_F->distancesInfo.numHands++;
	      
		//exit look for hand entity
		break;
	      }	    	    	    
	    } //end lok for entity for loop
	  }
	}
      } // end loop on hands
      SDI_F->distancesInfo.agents[curAgentIndex].numHands = SDI_F->distancesInfo.numHands-numHandsInDistManagementStart;

      // Add heads
      numHeadsInDistManagementStart = SDI_F->distancesInfo.numHeads;
      SDI_F->distancesInfo.agents[curAgentIndex].headIndex = -1;

      for(h_i=0; h_i<gAgents->all_agents[a_i]->head_nb; h_i++){
	//is there still place for a new head
	if(SDI_F->distancesInfo.numHeads == SDI_F->distancesInfo.numHeadsMax)
	  printf("Too many heads for distance management. num heads is %d max is %d.\n",SDI_F->distancesInfo.numHeads,SDI_F->distancesInfo.numHeadsMax);
	else{
	  if(h_i>0)
	    printf("We expect at most one heads for agent\n");
	  else{
	    //get head entity	  
	    for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
	      if (gAgents->all_agents[a_i]->head[h_i] == gEntities->entities[e_i]){
		curIndex = SDI_F->distancesInfo.numHeads;
		SDI_F->distancesInfo.agents[curAgentIndex].headIndex = curIndex;

		//add head
		SDI_F->distancesInfo.heads[curIndex].mainEntityIndex = entityIndex;
		SDI_F->distancesInfo.heads[curIndex].entityIndex = e_i;
		SDI_F->distancesInfo.heads[curIndex].mainEntityFamillyIndex = curIndex-numHeadsInDistManagementStart;
		SDI_F->distancesInfo.numHeads++;
		break;
	      }		
	    }
	  }
	}
      }
      SDI_F->distancesInfo.numAgents++;    
      break;
    }    
  }
  if(a_i<gAgents->all_agents_no)
    return true;
  else{
    printf("Agent was not found and cannot be added in Distance Management\n");
    return false;
  }
}

bool deleteAgentEntity(int entityIndex){
  int targetEntityIndex = -1;
  int deletedAgentNumHands = 0;
  int deletedAgentNumHeads = 0;
  int deletedAgentHeadIndex = 0;
  int deletedAgentFirstHandIndex = 0;

  for(int i = 0; i< SDI_F->distancesInfo.numAgents; i++){
    if(SDI_F->distancesInfo.agents[i].entityIndex == entityIndex){
      targetEntityIndex = i;
      break;
    }
  }
  if(targetEntityIndex > -1){
    deletedAgentNumHands = SDI_F->distancesInfo.agents[targetEntityIndex].numHands;
    deletedAgentHeadIndex = SDI_F->distancesInfo.agents[targetEntityIndex].headIndex;
    deletedAgentFirstHandIndex = SDI_F->distancesInfo.agents[targetEntityIndex].firstHandIndex;
    if(deletedAgentHeadIndex != -1)
      deletedAgentNumHeads = 1;
    
    for(int i = targetEntityIndex; i< SDI_F->distancesInfo.numAgents-1;i++){
      SDI_F->distancesInfo.agents[i].entityIndex = SDI_F->distancesInfo.agents[i+1].entityIndex; 
      strcpy(SDI_F->distancesInfo.agents[i].entityName.name,gEntities->entities[i+1]->robotPt->name);

      strcpy(SDI_F->distancesInfo.agents[i].baseJointName.name,SDI_F->distancesInfo.agents[i+1].baseJointName.name);
      SDI_F->distancesInfo.agents[i].allowPointingComputation = SDI_F->distancesInfo.agents[i+1].allowPointingComputation;
      SDI_F->distancesInfo.agents[i].allowGestureComputation = SDI_F->distancesInfo.agents[i+1].allowGestureComputation;
      SDI_F->distancesInfo.agents[i].allowAngleComputation = SDI_F->distancesInfo.agents[i+1].allowAngleComputation;
      SDI_F->distancesInfo.agents[i].firstHandIndex = SDI_F->distancesInfo.agents[i+1].firstHandIndex-deletedAgentNumHands;
      if( SDI_F->distancesInfo.agents[i+1].headIndex == -1)
	SDI_F->distancesInfo.agents[i].headIndex = -1;
      else
	SDI_F->distancesInfo.agents[i].headIndex = SDI_F->distancesInfo.agents[i+1].headIndex - deletedAgentNumHeads;
      SDI_F->distancesInfo.agents[i].numHands = 1;
    }
    SDI_F->distancesInfo.numAgents--;   
    
    //clean hands and arms
    if(deletedAgentNumHands>0){
      for(int i = deletedAgentFirstHandIndex; i< SDI_F->distancesInfo.numHands-deletedAgentNumHands;i++){
	SDI_F->distancesInfo.hands[i].mainEntityIndex = SDI_F->distancesInfo.hands[i+deletedAgentNumHands].mainEntityIndex;
	SDI_F->distancesInfo.hands[i].entityIndex = SDI_F->distancesInfo.hands[i+deletedAgentNumHands].entityIndex;
	SDI_F->distancesInfo.hands[i].mainEntityFamillyIndex = SDI_F->distancesInfo.hands[i+deletedAgentNumHands].mainEntityFamillyIndex;
	      
	//arm
	SDI_F->distancesInfo.arms[i].agentEntityIndex = SDI_F->distancesInfo.arms[i+deletedAgentNumHands].agentEntityIndex;
	SDI_F->distancesInfo.arms[i].mainEntityFamillyIndex = SDI_F->distancesInfo.arms[i+deletedAgentNumHands].mainEntityFamillyIndex;
	strcpy(SDI_F->distancesInfo.arms[i].shoulderJointName.name,SDI_F->distancesInfo.arms[i+deletedAgentNumHands].shoulderJointName.name);
      }
      
      SDI_F->distancesInfo.numHands-=deletedAgentNumHands;
    }

    // clean heads
    if(deletedAgentNumHeads>0){
      for(int i = deletedAgentHeadIndex; i< SDI_F->distancesInfo.numHeads-deletedAgentNumHeads;i++){
	SDI_F->distancesInfo.heads[i].mainEntityIndex = SDI_F->distancesInfo.heads[i+deletedAgentNumHeads].mainEntityIndex;
	SDI_F->distancesInfo.heads[i].entityIndex = SDI_F->distancesInfo.heads[i+deletedAgentNumHeads].entityIndex;
	SDI_F->distancesInfo.heads[i].mainEntityFamillyIndex = SDI_F->distancesInfo.heads[i+deletedAgentNumHeads].mainEntityFamillyIndex;
      }
      SDI_F->distancesInfo.numHeads-=deletedAgentNumHeads;
    }
  }
  return true;
}


bool checkIsPresentAgentEntity(int entityIndex){
  int targetEntityIndex = -1;

  for(int i = 0; i< SDI_F->distancesInfo.numAgents; i++){
    if(SDI_F->distancesInfo.agents[i].entityIndex == entityIndex){
      targetEntityIndex = i;
      break;
    }
  }
  if(targetEntityIndex > -1){
    return true;
  }
  return false;
}


bool addTableEntity(int entityIndex){
  if(SDI_F->distancesInfo.numTables == SDI_F->distancesInfo.numTablesMax){
    printf("Too many tables for distance management. Max is %d\n",SDI_F->distancesInfo.numTablesMax);
    return false;
  }

  int curIndex = SDI_F->distancesInfo.numTables;  
  SDI_F->distancesInfo.tables[curIndex].entityIndex = entityIndex; 
  strcpy(SDI_F->distancesInfo.tables[curIndex].entityName.name,gEntities->entities[entityIndex]->robotPt->name);
  SDI_F->distancesInfo.tables[curIndex].firstTablePointIndex = -1;

  UpdateTablePointsInDistanceManagement(entityIndex,curIndex);
  SDI_F->distancesInfo.numTables++;
  return true;
}

bool deleteTableEntityTablePoints(int entityIndex,int deletedTableNumTablePoints,int deletedTableFirstTablePointIndex){
  for(int i = deletedTableFirstTablePointIndex; i< SDI_F->distancesInfo.numTablePoints-deletedTableNumTablePoints;  i++){
    SDI_F->distancesInfo.tablePoints[i].mainEntityIndex = SDI_F->distancesInfo.tablePoints[i+deletedTableNumTablePoints].mainEntityIndex;
    SDI_F->distancesInfo.tablePoints[i].entityIndex = -1;
    SDI_F->distancesInfo.tablePoints[i].mainEntityFamillyIndex = SDI_F->distancesInfo.tablePoints[i+deletedTableNumTablePoints].mainEntityFamillyIndex;      
  }
  SDI_F->distancesInfo.numTablePoints-=deletedTableNumTablePoints;
  return true;
}


bool deleteTableEntity(int entityIndex){
  int targetEntityIndex = -1;
  int deletedTableNumTablePoints = 0;
  int deletedTableFirstTablePointIndex = 0;
  for(int i = 0; i< SDI_F->distancesInfo.numTables; i++){
    if(SDI_F->distancesInfo.tables[i].entityIndex == entityIndex){
      targetEntityIndex = i;
      break;
    }
  }
  if(targetEntityIndex > -1){
    deletedTableNumTablePoints = SDI_F->distancesInfo.tables[targetEntityIndex].numTablePoints;

    if(deletedTableNumTablePoints > 0){
      deletedTableFirstTablePointIndex = SDI_F->distancesInfo.tables[targetEntityIndex].firstTablePointIndex;
      deleteTableEntityTablePoints(entityIndex,deletedTableNumTablePoints,deletedTableFirstTablePointIndex);
    }

    for(int i = targetEntityIndex; i< SDI_F->distancesInfo.numTables-1; i++){
      SDI_F->distancesInfo.tables[i].entityIndex = SDI_F->distancesInfo.tables[i+1].entityIndex; 
      strcpy(SDI_F->distancesInfo.tables[i].entityName.name,SDI_F->distancesInfo.tables[i+1].entityName.name);
      SDI_F->distancesInfo.tables[i].numTablePoints = SDI_F->distancesInfo.tables[i+1].numTablePoints;
      SDI_F->distancesInfo.tables[i].firstTablePointIndex = SDI_F->distancesInfo.tables[i+1].firstTablePointIndex-deletedTableNumTablePoints;

      for(int j = 0; j< 4; j++)
	copyVec(SDI_F->distancesInfo.tables[i+1].tableCornersPositions[j],SDI_F->distancesInfo.tables[i].tableCornersPositions[j]);
      
    }
    SDI_F->distancesInfo.numTables--;
  }
  return true;
}

bool checkIsPresentTableEntity(int entityIndex){
  int targetEntityIndex = -1;
  for(int i = 0; i< SDI_F->distancesInfo.numTables; i++){
    if(SDI_F->distancesInfo.tables[i].entityIndex == entityIndex){
      targetEntityIndex = i;
      break;
    }
  }
  if(targetEntityIndex > -1){
    return true;
  }
  return false;
}


bool addObjectEntity(int entityIndex){
  if(SDI_F->distancesInfo.numObjects == SDI_F->distancesInfo.numObjectsMax){
    printf("Too many objects for distance management. Max is %d\n",SDI_F->distancesInfo.numObjectsMax);
    return false;
  }
  int curIndex = SDI_F->distancesInfo.numObjects;  
  SDI_F->distancesInfo.objects[curIndex].entityIndex = entityIndex; 
  strcpy(SDI_F->distancesInfo.objects[curIndex].entityName.name,gEntities->entities[entityIndex]->robotPt->name);
  SDI_F->distancesInfo.numObjects++;
  return true;
}

bool deleteObjectEntity(int entityIndex){
  int targetEntityIndex = -1;
  for(int i = 0; i< SDI_F->distancesInfo.numObjects; i++){
    if(SDI_F->distancesInfo.objects[i].entityIndex == entityIndex){
      targetEntityIndex = i;
      break;
    }
  }
  if(targetEntityIndex > -1){
    for(int i = targetEntityIndex; i< SDI_F->distancesInfo.numObjects-1; i++){
      SDI_F->distancesInfo.objects[i].entityIndex = SDI_F->distancesInfo.objects[i+1].entityIndex;
      strcpy(SDI_F->distancesInfo.objects[i].entityName.name,SDI_F->distancesInfo.objects[i+1].entityName.name);
    }
    SDI_F->distancesInfo.numObjects--;
  }
  return true;
}

bool checkIsPresentObjectEntity(int entityIndex){
  int targetEntityIndex = -1;
  for(int i = 0; i< SDI_F->distancesInfo.numObjects; i++){
    if(SDI_F->distancesInfo.objects[i].entityIndex == entityIndex){
      targetEntityIndex = i;
      break;
    }
  }
  if(targetEntityIndex > -1){
    return true;
  }
  else
    return false;
}

bool checkEntityIsPresentInDistanceManagement(int entityIndex){

  //right now, just copy the entity in table.
  if(gEntities->entities[entityIndex]->subtype == HRI_OBJECT_SUPPORT){
    return checkIsPresentTableEntity(entityIndex);
  }
   
  else if(gEntities->entities[entityIndex]->subtype == HRI_MOVABLE_OBJECT){
    return checkIsPresentObjectEntity(entityIndex);    
  }

  else if(gEntities->entities[entityIndex]->type == HRI_ISAGENT){
    return checkIsPresentAgentEntity(entityIndex);
  }
  else{ 
    printf("Unmanaged entity type %d and subtype %d for distance management.\n",gEntities->entities[entityIndex]->type,gEntities->entities[entityIndex]->subtype);
    return false;
  }
}

bool deleteEntityInDistanceManagement(int entityIndex){

  //right now, just copy the entity in table.
  if(gEntities->entities[entityIndex]->subtype == HRI_OBJECT_SUPPORT){
    return deleteTableEntity(entityIndex);
  }
   
  else if(gEntities->entities[entityIndex]->subtype == HRI_MOVABLE_OBJECT){
    return deleteObjectEntity(entityIndex);    
  }

  else if(gEntities->entities[entityIndex]->type == HRI_ISAGENT){
    return deleteAgentEntity(entityIndex);
  }
  else{ 
    printf("Unmanaged entity type %d and subtype %d for distance management.\n",gEntities->entities[entityIndex]->type,gEntities->entities[entityIndex]->subtype);
    return false;
  }
}


bool addEntityInDistanceManagement(int entityIndex,int modifyParameterCommand , double doubleParameterValue,  int intParameterValue, GEN_STRING64  baseJointName,GEN_STRING64  shoulderJointName0,GEN_STRING64  shoulderJointName1){

  //right now, just copy the entity in table.
  if(gEntities->entities[entityIndex]->subtype == HRI_OBJECT_SUPPORT){
    return addTableEntity(entityIndex);
  }
   
  else if(gEntities->entities[entityIndex]->subtype == HRI_MOVABLE_OBJECT){
    return addObjectEntity(entityIndex);    
  }

  else if(gEntities->entities[entityIndex]->type == HRI_ISAGENT){
    return addAgentEntity(entityIndex,modifyParameterCommand, doubleParameterValue, intParameterValue,baseJointName,shoulderJointName0,shoulderJointName1);
  }
  else{ 
    printf("Unmanaged entity type %d and subtype %d for distance management.\n",gEntities->entities[entityIndex]->type,gEntities->entities[entityIndex]->subtype);
    return false;
  }
}

void getPointDistToTableFromPointOutsideTableRectangle (SPARK_3D_COORD point, SPARK_3D_COORD tableCorners[], double &dist,SPARK_3D_COORD &closestTablePoint){

  double minDist = 0.0;
  double maxDist = 0.0;
  int minDistIndex = 0;
  int maxDistIndex = 0;

  double some2DDist[4];
  double rectangleL = 0;
  double alpha;

  SPARK_3D_COORD pointA;
  SPARK_3D_COORD pointB[2];
  SPARK_3D_COORD closestTablePointTmp[2];
  double distTmp[2];

  //get closest and furthest corners.
  for(int i = 0; i<4 ; i++){
    some2DDist[i] = get2DDistanceBetweenPoints(point,tableCorners[i]);
    if(i == 0){
      minDist = some2DDist[0];
      maxDist = some2DDist[0];
      minDistIndex = 0;
      maxDistIndex = 0;
    }
    else{
      if(some2DDist[i] < minDist){
	minDist = some2DDist[i];
	minDistIndex = i;
      }
      if(some2DDist[i] > maxDist){
	maxDist = some2DDist[i];
	maxDistIndex = i;
      }	        
    }
  }
  
  // to get the closest point, we have to compute the orthogonal projection with the two rectangle side that link the closest corner and the not furthest two other corners.
  
  copyVec(tableCorners[minDistIndex],pointA);
  int iterOnOtherCorners = 0;
  for(int i = 0; i<4 ; i++){
    if( (i != minDistIndex) && (i != maxDistIndex) ){
      copyVec(tableCorners[i],pointB[iterOnOtherCorners]);
      //distToB[i]=some2DDist[i];

      rectangleL = get2DDistanceBetweenPoints(pointA,pointB[iterOnOtherCorners]);
      /// vecAI = alpha * vecAB
      ///use pythagore to compute alpha so that vecAI = alpha*vecAB
      ///if alpha > 0 I is the closest point otherwise it is A.      
      alpha = (pow(minDist,2)-pow(some2DDist[iterOnOtherCorners],2))/(2*pow(rectangleL,2))+0.5;
      if(alpha>0)
	getPointAtAlphaFromVecAB(alpha,pointA,pointB[iterOnOtherCorners],closestTablePointTmp[iterOnOtherCorners]);
      else
	copyVec(pointA,closestTablePointTmp[iterOnOtherCorners]);
  
      distTmp[iterOnOtherCorners] = getDistanceBetweenPoints(point,closestTablePointTmp[iterOnOtherCorners]);
      iterOnOtherCorners++;
    }    
  }
  
  // find which distance is the smallest. Save it in the iterator.
  if(distTmp[0]<distTmp[1])
    iterOnOtherCorners = 0;
  else
    iterOnOtherCorners = 1;

  dist = distTmp[iterOnOtherCorners]; 
  copyVec(closestTablePointTmp[iterOnOtherCorners],closestTablePoint);
  
  closestTablePoint.z = point.z;
}

// bool getIntersectionWithHorizontalPlan(SPARK_3D_COORD startPoint,SPARK_3D_COORD directionVec,double planHeight,SPARK_3D_COORD &planInterPoint){

bool isPointInsideTableRectangle(SPARK_3D_COORD point, SPARK_3D_COORD tableCorners[]){
  SPARK_3D_COORD vecToCorners[4];
  SPARK_3D_COORD prodVec[3];

  double angles[3];
  double minAngle = 0;
  double maxAngle = 0;
  double angleRange = 0;
  double scalProd = 0;

  // compute angle between vecPointToCorner.
  // printf("Check is inside table rectangle\n");
  // printf("point coordinates : %f %f %f\n",point.x,point.y,point.z);
  for(int i = 0; i<4 ; i++){
    getVecABFromPointAAndPointB(point,tableCorners[i],vecToCorners[i]);
    vecToCorners[i].z = 0;
    normalizeVec(vecToCorners[i]);

    if( i > 0){
      getVecProdVecOnPlanZ0(vecToCorners[0],vecToCorners[i],prodVec[i-1]);

      angles[i-1] = asin(prodVec[i-1].z);
      ///check if angle is actually bigger than m
      scalProd = getVecScalProd(vecToCorners[0],vecToCorners[i]);
      if(scalProd < 0){
	if(angles[i-1]>0)
	  angles[i-1] = M_PI - angles[i-1];
	else
	  angles[i-1] = -1*M_PI - angles[i-1];
      }
      if (i == 1){
	minAngle = angles[i-1];
	maxAngle = angles[i-1];
      }
      else{
	if(angles[i-1]<minAngle)
	  minAngle = angles[i-1];
	if(angles[i-1]>maxAngle)
	  maxAngle = angles[i-1];
      }      
    }
  }
  angleRange = maxAngle - minAngle;
    
  //point is inside table rectangle if angleRange > PI
  if(angleRange > M_PI)
    return true;
  else
    return false;  
}

void getPointDistToTable(SPARK_3D_COORD point, SPARK_3D_COORD tableCorners[], double &dist, int& isAbove,SPARK_3D_COORD &closestTablePoint){

  double tableHeight = tableCorners[0].z;

  if(isPointInsideTableRectangle(point,tableCorners)){
    dist = fabs(point.z - tableHeight);
    copyVec(point,closestTablePoint);
    //closestTablePoint.z = tableHeight; 
    isAbove = 1;
  }
  else{
    getPointDistToTableFromPointOutsideTableRectangle(point,tableCorners,dist,closestTablePoint);
    isAbove = 0;
  }
}

bool isArmPointingTowardTable(double maxDistFromTable,SPARK_3D_COORD shoulderPoint,SPARK_3D_COORD armVector, SPARK_3D_COORD tableCorners[],SPARK_3D_COORD &pointPointedOnTablePlan){
  double tableHeight = tableCorners[0].z;
  double someDist = 0;
  SPARK_3D_COORD intersectionWithTablePlan;
  SPARK_3D_COORD closestTablePlan;
  
  if(getIntersectionWithHorizontalPlan(shoulderPoint,armVector,tableHeight,intersectionWithTablePlan)){
    bool isPointInsideTableRectangleBool = isPointInsideTableRectangle(intersectionWithTablePlan,tableCorners);
    copyVec(intersectionWithTablePlan,pointPointedOnTablePlan);
    if(isPointInsideTableRectangleBool){
      return true;
    }
    else{
      getPointDistToTableFromPointOutsideTableRectangle(intersectionWithTablePlan,tableCorners,someDist,closestTablePlan);
      if(someDist<maxDistFromTable)
	return true;
      else
	return false;
    }
  }
  else
    return false;
}

void getJointXYZYaw (p3d_rob* rob , GEN_STRING64 jointName ,SPARK_3D_COORD &jointCoord, double &yaw){
  p3d_jnt* jnt;
  jnt = p3d_get_robot_jnt_by_name( rob, jointName.name);
  T3D* jointToOrigin = t3dNew( T3D_MATRIX, T3D_ALLOW_CONVERSION );
  for(unsigned int i=0; i<4; i++) {
    for(unsigned int j=0; j<4; j++) {
      jointToOrigin->matrix[4*i+j] = jnt->abs_pos[i][j];
    }
  }
  t3dConvertTo( T3D_BRYAN, jointToOrigin );
  yaw = jointToOrigin->euler.yaw;
  jointCoord.x = jointToOrigin->euler.x;
  jointCoord.y = jointToOrigin->euler.y;
  jointCoord.z = jointToOrigin->euler.z;
}

void getOrientationVector(double yaw, SPARK_3D_COORD &orientation){
  orientation.x=cos(yaw);
  orientation.y=sin(yaw);
  orientation.z=0;
}


void getEntityBBCenter( HRI_ENTITY * entity, bool useZMax, SPARK_3D_COORD &centerPoint){
  if((entity->type == HRI_OBJECT_PART) || (entity->type == HRI_AGENT_PART)) {
    centerPoint.x = (entity->partPt->BB.xmax + entity->partPt->BB.xmin)/2;
    centerPoint.y = (entity->partPt->BB.ymax + entity->partPt->BB.ymin)/2;
    //we want table top
    if( useZMax )
      centerPoint.z = entity->partPt->BB.zmax;
    else
      centerPoint.z = (entity->partPt->BB.zmax + entity->partPt->BB.zmin)/2;
  }
  else {
    centerPoint.x = (entity->robotPt->BB.xmax + entity->robotPt->BB.xmin)/2;
    centerPoint.y = (entity->robotPt->BB.ymax + entity->robotPt->BB.ymin)/2;
    //we want table top
    if( useZMax )
      centerPoint.z = entity->robotPt->BB.zmax;
    else
      centerPoint.z = (entity->robotPt->BB.zmax + entity->robotPt->BB.zmin)/2;
  }
}

void updateDistAndMinDist( int iter1 , int iter2, SPARK_3D_COORD point1, SPARK_3D_COORD point2, int forceReinitMinDist, double aTime,int &index1,int &index2, double &curDist, double &minDist , double &minDistTime ){

  index1 = iter1;
  index2 = iter2;
  curDist = getDistanceBetweenPoints(point1,point2);
  
  //update minDist if needed
  if ( (curDist < minDist) || forceReinitMinDist){
    minDist = curDist;
    minDistTime = aTime;
  }
}

void updateAngleNew( int indexInput1 , int indexInput2, SPARK_3D_COORD orientation, SPARK_3D_COORD pointStart, SPARK_3D_COORD pointEnd,int &index1,int &index2, double &curAngle){
  SPARK_3D_COORD vec;
  SPARK_3D_COORD prodVec;
  index1 = indexInput1;
  index2 = indexInput2;
 
  getVecABFromPointAAndPointB(pointStart,pointEnd,vec);
  vec.z = 0;
  normalizeVec(vec);
  
  getVecProdVecOnPlanZ0(orientation,vec,prodVec);
  curAngle = asin(prodVec.z);  
}


void updatePointing( int indexInput1 , int indexInput2, SPARK_3D_COORD shoulderToHandVec, SPARK_3D_COORD shoulder, SPARK_3D_COORD pointEnd,double armLength,double armLengthMax,int &index1,int &index2, SPARK_3D_COORD & optimalPointingVec, SPARK_3D_COORD & optimalPointingPoint , double & curAngleFromOptimalPointingVec ,double & pointingScore){

  SPARK_3D_COORD normalizedPointingVec;
  //SPARK_3D_COORD normalizedArmVec;
  double scalProd = 0;

  index1 = indexInput1;
  index2 = indexInput2;
 
  //get normalized pointing vec.
  getVecABFromPointAAndPointB(shoulder,pointEnd,normalizedPointingVec);
  normalizeVec(normalizedPointingVec);

  //compute angle between pointing vec and arm vec
  scalProd = getVecScalProd(shoulderToHandVec,normalizedPointingVec);
  curAngleFromOptimalPointingVec = acos(scalProd);

  //get optimal pointing vec.
  copyVec(normalizedPointingVec,optimalPointingVec);
  getMultVec(optimalPointingVec,0.9*armLengthMax);

  //compute optimal pointing point.
  getPointBFromPointAAndVecAB(shoulder,optimalPointingVec,optimalPointingPoint);
  
  //update score.
  if(armLength > armLength*0.8){
    if(curAngleFromOptimalPointingVec < M_PI/8){
      if(pointingScore<1.0)
	pointingScore+=0.1;    
      else{
	if(pointingScore>0)
	  pointingScore-=0.1;    
      }
    }
    else{
      if(pointingScore>0)
	pointingScore-=0.1; 
    }
  }
  else{
    if(pointingScore>0)
      pointingScore-=0.1;   
  }
}

bool getTrajIndexAndTimeStepIndex(int agentIndex,int handIndex, int entityIndex, int& trajIndex,int &timeStepIndex){
  int firstFreeTrajIndex = -1;
  trajIndex = -1;
  timeStepIndex = 0;
  for(int i = 0; i< SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX; i++){

    if((firstFreeTrajIndex == -1) && (SDI_F->distancesInfo.trajectories[i].agentIndex == -1))
      firstFreeTrajIndex = i;
    
    if((agentIndex == SDI_F->distancesInfo.trajectories[i].agentIndex) && (handIndex == SDI_F->distancesInfo.trajectories[i].handIndex) && (entityIndex == SDI_F->distancesInfo.trajectories[i].entityIndex)){
      trajIndex = i;
      timeStepIndex = SDI_F->distancesInfo.trajectories[i].curTimeStepIndex+1;
      break;
    }
  }
  
  if((trajIndex == -1) || (timeStepIndex == SPARK_DISTANCES_INFO_NUM_STEP_IN_TRAJECTORY_MAX)){
    if(firstFreeTrajIndex != -1){
      trajIndex = firstFreeTrajIndex;
      timeStepIndex = 0;
    }
    else{
      printf("no more free trajectories index\n");	 
      return false;
    }
      
  }
  return true;
}


bool getDistHistoricIndexAndTimeStepIndex(int agentIndex,int handIndex, int entityIndex, int& distHistoricIndex,int &timeStepIndex){
  int firstFreeDistHistoricIndex = -1;
  distHistoricIndex = -1;
  timeStepIndex = 0;
  for(int i = 0; i< SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX; i++){

    if((firstFreeDistHistoricIndex == -1) && (SDI_F->distancesInfo.distanceHistories[i].agentIndex == -1))
      firstFreeDistHistoricIndex = i;
    
    if((agentIndex == SDI_F->distancesInfo.distanceHistories[i].agentIndex) && (handIndex == SDI_F->distancesInfo.distanceHistories[i].handIndex) && (entityIndex == SDI_F->distancesInfo.distanceHistories[i].entityIndex)){
      distHistoricIndex = i;
      timeStepIndex = SDI_F->distancesInfo.distanceHistories[i].curTimeStepIndex+1;
      break;
    }
  }
  
  if((distHistoricIndex == -1) || (timeStepIndex == SPARK_DISTANCES_INFO_NUM_STEP_IN_TRAJECTORY_MAX)){
    if( firstFreeDistHistoricIndex != -1){
      distHistoricIndex = firstFreeDistHistoricIndex;
      timeStepIndex = 0;
    }
    else{
      printf("no more free histories index\n");	 
      return false;
    }
      
  }
  return true;
}


// bool findHandTrajectoryFreeIndex(int &freeIndex){
//   for(int i = 0; i< SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX; i++){
//     if(SDI_F->distancesInfo.trajectories[i].handIndex == -1){
//       freeIndex = i;
//       return true;
//     }
//   }
//   // all slot are taken. We take first one
//   freeIndex = 0;
//   return false;
// }

// bool findDistanceHistoricFreeIndex(int &freeIndex){
//   for(int i = 0; i< SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX; i++){
//     if(SDI_F->distancesInfo.distanceHistories[i].handIndex == -1){
//       freeIndex = i;
//       return true;
//     }
//   }
//   // all slot are taken. We take first one
//   freeIndex = 0;
//   return false;
// }

void updateDistAndMinDistToTable( int agentIndex, int indexInput1 ,int indexInput2, bool isHand , bool saveHistory , double saveHistoryDistThreshold,  SPARK_3D_COORD point1, SPARK_3D_COORD tableCorners[], int forceReinitMinDist, double aTime,int &index1,int &index2, double &curDist,  int &isAbove , SPARK_3D_COORD &closestPoint ,double &minDist , double &minDistTime , SPARK_3D_COORD &minDistPoint ,int &trajIndex , int &distHistIndex , int &timeStepIndex ){

  double dist = 0;
  int handIndex = indexInput1;
  int entityIndex = indexInput2;
  getPointDistToTable(point1,tableCorners,dist,isAbove,closestPoint);
  curDist = dist;

  if ( isHand && saveHistory && (dist < saveHistoryDistThreshold)){
    bool saveTraj = getTrajIndexAndTimeStepIndex(agentIndex,handIndex, entityIndex,trajIndex,timeStepIndex);

    if( saveTraj && (timeStepIndex == 0) ){
      SDI_F->distancesInfo.trajectories[trajIndex].agentIndex = agentIndex;
      SDI_F->distancesInfo.trajectories[trajIndex].handIndex = handIndex;
      SDI_F->distancesInfo.trajectories[trajIndex].entityIndex = entityIndex;
    }
    
    bool saveValue = saveTraj;
    //check distance between previous value
    if( saveValue && (timeStepIndex>0)){
      if(getDistanceBetweenPoints(SDI_F->distancesInfo.trajectories[trajIndex].positions[timeStepIndex-1],closestPoint)<0.05)
	saveValue = false;      
    }
    
    
    if( saveValue ){ 
      //copyVec(closestPoint,SDI_F->distancesInfo.trajectories[trajIndex].positions[timeStepIndex]);
      copyVec(point1,SDI_F->distancesInfo.trajectories[trajIndex].positions[timeStepIndex]);
      SDI_F->distancesInfo.trajectories[trajIndex].timeSteps[timeStepIndex] = aTime;
      SDI_F->distancesInfo.trajectories[trajIndex].curTimeStepIndex = timeStepIndex;
    }

    // bool saveDistHistories = getDistHistoricIndexAndTimeStepIndex(agentIndex,handIndex, entityIndex,distHistIndex,timeStepIndex);
    //   SDI_F->distancesInfo.distanceHistories[distHistIndex].handIndex = indexInput1;
    //   SDI_F->distancesInfo.distanceHistories[distHistIndex].index = indexInput2;
    //   timeStepIndex = 0;
    // }
    // SDI_F->distancesInfo.distanceHistories[distHistIndex].distances[timeStepIndex] = dist;
    // SDI_F->distancesInfo.distanceHistories[distHistIndex].timeSteps[timeStepIndex] = aTime;
    // timeStepIndex++;
  }
  
  //update minDist if needed
  if ( (curDist < minDist) || forceReinitMinDist){
    minDist = curDist;
    minDistTime = aTime;
    copyVec(point1,minDistPoint);
  }
}

void updateArmSemaphoreAlphabet(SPARK_3D_COORD orientation,SPARK_3D_COORD armVector,double armVectorLength,double armVectorLengthMax, SPARK_DISTANCES_ARM_ANGLE_INFO &armAngleInfo){

  // check length is big enough
  if(armVectorLength > armVectorLengthMax*0.8){
    // normalize arm vector
    SPARK_3D_COORD normalizedArmVector;
    SPARK_3D_COORD verticalVec;
    SPARK_3D_COORD prodVec;
    SPARK_3D_COORD someTranslation;

    double scalProd,angle,angleFromPlan;
    copyVec(armVector,normalizedArmVector);
    normalizeVec(normalizedArmVector);
    scalProd = getVecScalProd(normalizedArmVector,orientation);

    armAngleInfo.curAngleScore = 1-fabs(scalProd);
    
    // check arm vector is in plan orthogonal to orientation
    angleFromPlan = acos(scalProd);
    angleFromPlan -= M_PI/2;
    if(fabs(angleFromPlan)<M_PI/6){

      // get vertical
      verticalVec.x=0;
      verticalVec.y=0;
      verticalVec.z=1;
      
      //get exact normalized projection
      copyVec(orientation,someTranslation);
      getMultVec(someTranslation,-scalProd);
      getVecsSum(normalizedArmVector,someTranslation,normalizedArmVector);
      normalizeVec(normalizedArmVector);

      // get angle
      getVecProd(verticalVec,normalizedArmVector,prodVec);
      scalProd=getVecScalProd(prodVec,orientation);
      angle = asin(scalProd);
      
      // compare to average angle
      armAngleInfo.curAngle = angle;

      if(fabs(armAngleInfo.angleRef - angle) < M_PI/8){
	if(armAngleInfo.angleRefScore<1.0)
	  armAngleInfo.angleRefScore+=0.1;
      }
      else{
	if(armAngleInfo.angleRefScore>0)
	  armAngleInfo.angleRefScore-=0.1;
	else
	  armAngleInfo.angleRef = angle;
      }
    }
    else{
      if(armAngleInfo.angleRefScore>0)
	armAngleInfo.angleRefScore-=0.1;
    }
  }
  else{
    if(armAngleInfo.angleRefScore>0)
      armAngleInfo.angleRefScore-=0.1;
  }
}

void computeDistancesAndFillDistanceManagementPoster2( void ){
  int numAgents = SDI_F->distancesInfo.numAgents;
  int numObjects = SDI_F->distancesInfo.numObjects;
  int numTables = SDI_F->distancesInfo.numTables;
  int numHands = SDI_F->distancesInfo.numHands;
  int numHeads = SDI_F->distancesInfo.numHeads;
  //int numTablePoints = SDI_F->distancesInfo.numTablePoints;
  double distThreshold = SDI_F->distancesInfo.distThreshold;
  //double distThresholdSmall = SDI_F->distancesInfo.distThresholdSmall;
  int saveHistory = SDI_F->distancesInfo.saveHistory;
  double saveHistoryDistanceThreshold = SDI_F->distancesInfo.saveHistoryDistanceThreshold;

  int entityIndex,agentEntityIndex;
  HRI_ENTITY * entity;
  p3d_rob* rob;
  double yaw;

  SPARK_3D_COORD aPoint;
  int anInt;
  double aDist;
  int forceReinitMinDist = SDI_F->distancesInfo.forceReinitMinDist;
  double aTime = 0.0;
  int checkArmVectorLengthMax = SDI_F->distancesInfo.checkArmVectorLengthMax;
  int reinitArmVectorLengthMax = SDI_F->distancesInfo.reinitArmVectorLengthMax;

  //////////////////////
  //  update positions
  //////////////////////

  ///update agent positions and orientation.
  for(int i = 0; i< numAgents; i++){
    entityIndex = SDI_F->distancesInfo.agents[i].entityIndex;
    entity = gEntities->entities[entityIndex];
    //getEntityBBCenter(entity,false,SDI_F->distancesInfo.agents.position); 
    rob = entity->robotPt;
    //printf("rob name : %s %s\n",entity->robotPt->name,SDI_F->distancesInfo.agents[i].baseJointName.name);	 
    getJointXYZYaw ( rob, SDI_F->distancesInfo.agents[i].baseJointName ,SDI_F->distancesInfo.agents[i].position, yaw);
    getOrientationVector(yaw,SDI_F->distancesInfo.agents[i].orientation);
  }

  ///update object positions
  for(int i = 0; i< numObjects; i++){
    entityIndex = SDI_F->distancesInfo.objects[i].entityIndex;
    entity = gEntities->entities[entityIndex];
    getEntityBBCenter(entity,false,SDI_F->distancesInfo.objects[i].position); 
  }

  ///check table center position.
  for(int i = 0; i< numTables; i++){
    entityIndex = SDI_F->distancesInfo.tables[i].entityIndex;
    entity = gEntities->entities[entityIndex];

    //Check wether table has moved to test wether we should update corner and table points.
    getEntityBBCenter(entity,false,aPoint);
    aDist = getDistanceBetweenPoints(aPoint,SDI_F->distancesInfo.tables[i].position);
    if( (aDist > 0.2) || SDI_F->distancesInfo.forceUpdateTablesPosition){
      copyVec(aPoint,SDI_F->distancesInfo.tables[i].position);
      if(needToUpdateTableCorners(entityIndex,SDI_F->distancesInfo.tables[i].tableCornersPositions,0.4)|| SDI_F->distancesInfo.forceUpdateTablesPosition){
	deleteTableEntityTablePoints(entityIndex,SDI_F->distancesInfo.tables[i].numTablePoints,SDI_F->distancesInfo.tables[i].firstTablePointIndex);
	UpdateTablePointsInDistanceManagement(entityIndex,i);
      }    
      SDI_F->distancesInfo.forceUpdateTablesPosition = FALSE;
    }
  }  
  
  // update hands and arms
  for(int i = 0; i< numHands; i++){
    entityIndex = SDI_F->distancesInfo.hands[i].entityIndex;
    entity = gEntities->entities[entityIndex];
    getEntityBBCenter(entity,false,SDI_F->distancesInfo.hands[i].position); 

    agentEntityIndex = SDI_F->distancesInfo.arms[i].agentEntityIndex;

    //update shoulder positions
    entityIndex = SDI_F->distancesInfo.arms[i].agentEntityIndex;
    entity = gEntities->entities[entityIndex];
    rob = entity->robotPt;
    getJointXYZYaw ( rob, SDI_F->distancesInfo.arms[i].shoulderJointName ,SDI_F->distancesInfo.arms[i].shoulderPosition, yaw);


    if(SDI_F->distancesInfo.agents[agentEntityIndex].allowPointingComputation || SDI_F->distancesInfo.agents[agentEntityIndex].allowGestureComputation){
      getVecABFromPointAAndPointB(SDI_F->distancesInfo.arms[i].shoulderPosition,SDI_F->distancesInfo.hands[i].position,SDI_F->distancesInfo.arms[i].armVector);
      SDI_F->distancesInfo.arms[i].armVectorLength = getVecDistance(SDI_F->distancesInfo.arms[i].armVector);

      if(reinitArmVectorLengthMax || (checkArmVectorLengthMax && (SDI_F->distancesInfo.arms[i].armVectorLengthMax > 2))){
	SDI_F->distancesInfo.arms[i].armVectorLengthMax = 0;
      }
      if(SDI_F->distancesInfo.arms[i].armVectorLength > SDI_F->distancesInfo.arms[i].armVectorLengthMax)
	SDI_F->distancesInfo.arms[i].armVectorLengthMax = SDI_F->distancesInfo.arms[i].armVectorLength;

      if(SDI_F->distancesInfo.agents[agentEntityIndex].allowGestureComputation)
	updateArmSemaphoreAlphabet(SDI_F->distancesInfo.agents[agentEntityIndex].orientation,SDI_F->distancesInfo.arms[i].armVector,SDI_F->distancesInfo.arms[i].armVectorLength,SDI_F->distancesInfo.arms[i].armVectorLengthMax,SDI_F->distancesInfo.arms[i].armAngleInfo);
    }
  }
  
  SDI_F->distancesInfo.checkArmVectorLengthMax = FALSE;
  SDI_F->distancesInfo.reinitArmVectorLengthMax = FALSE;

  // update heads
  for(int i = 0; i< numHeads; i++){
    entityIndex = SDI_F->distancesInfo.heads[i].entityIndex;
    entity = gEntities->entities[entityIndex];
    getEntityBBCenter(entity,false,SDI_F->distancesInfo.heads[i].position); 
  }
  
  // all positions are older than this time
  aTime = getTimeInSecondMilisecond()-SDI_F->distancesInfo.initialTime;

  //////////////////////
  //  update distances and angles
  //////////////////////

  ///////////////////////////////
  // agent / agent distances.
  ///////////////////////////////

  int someIterAgentAgent = 0;
  int someIterAgentHand = 0;
  int someIterHandHand = 0;  
  int someIterAgentAgentAngle = 0; 
  int someIterAgentHeadPointing = 0; 

  int firstHandIndex = 0;
  int firstHandIndex2 = 0;
  int headIndex = 0;
  int headIndex2 = 0;
  numHands = 0;
  int numHands2 = 0;

  for(int i = 0; i< numAgents; i++){
    for(int j = i+1; j< numAgents; j++){
      if(someIterAgentAgent < SDI_F->distancesInfo.numAgentAgentDistsMax){
	updateDistAndMinDist(i,j,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.agents[j].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].index1,SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].index2,SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].curDist,SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].minDist, SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].minDistTime);

       
	////////////////////////////////////////
	//allow to compute distance involving these agent hands.
	/////////////////////////////////////////
	if(SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].curDist < distThreshold){
	  firstHandIndex = SDI_F->distancesInfo.agents[i].firstHandIndex;
	  firstHandIndex2 = SDI_F->distancesInfo.agents[j].firstHandIndex;
	  headIndex = SDI_F->distancesInfo.agents[i].headIndex;
	  headIndex2 = SDI_F->distancesInfo.agents[j].headIndex;
	  numHands = SDI_F->distancesInfo.agents[i].numHands;
	  numHands2 = SDI_F->distancesInfo.agents[j].numHands;

	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstHandHandIndex = someIterHandHand;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHandIndex = someIterAgentHand;
	 
	  ///////////////////
	  //  betwee nhands
	  ///////////////////
	  for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){
	    for(int l = firstHandIndex2; l< firstHandIndex2 + numHands2; l++){
	      if(someIterHandHand < SDI_F->distancesInfo.numHandHandDistsMax){
		updateDistAndMinDist(k,l,SDI_F->distancesInfo.hands[k].position,SDI_F->distancesInfo.hands[l].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.handHandDists[someIterHandHand].index1,SDI_F->distancesInfo.handHandDists[someIterHandHand].index2,SDI_F->distancesInfo.handHandDists[someIterHandHand].curDist,SDI_F->distancesInfo.handHandDists[someIterHandHand].minDist,SDI_F->distancesInfo.handHandDists[someIterHandHand].minDistTime);
		someIterHandHand++;
	      }
	      else
		printf("Too many hand hand dists. Max is %d\n",SDI_F->distancesInfo.numHandHandDistsMax);	    
	    }
	  }
	  SDI_F->distancesInfo.numHandHandDists = someIterHandHand;
	 
	  /////////////
	  // between hand and agent
	  ///////////

	  for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){
	    if(someIterAgentHand < SDI_F->distancesInfo.numAgentHandDistsMax){
	      updateDistAndMinDist(j,k,SDI_F->distancesInfo.hands[k].position,SDI_F->distancesInfo.agents[j].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].index1,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].index2,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].curDist,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].minDist,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].minDistTime);
	      someIterAgentHand++;
	    }
	    else
	      printf("Too many agent hand dists. Max is %d\n",SDI_F->distancesInfo.numAgentHandDistsMax);
	  }
	  SDI_F->distancesInfo.numAgentHandDists = someIterAgentHand;
	 
	  for(int l = firstHandIndex2; l< firstHandIndex2 + numHands2; l++){
	    if(someIterAgentHand < SDI_F->distancesInfo.numAgentHandDistsMax){	       
	      updateDistAndMinDist(i,l,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.hands[l].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].index1,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].index2,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].curDist,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].minDist,SDI_F->distancesInfo.agentHandDists[someIterAgentHand].minDistTime);
	      someIterAgentHand ++;
	    }
	    else
	      printf("Too many agent hand dists. Max is %d\n",SDI_F->distancesInfo.numAgentHandDistsMax);
	  }
	  SDI_F->distancesInfo.numAgentHandDists = someIterAgentHand;
	
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].lastHandHandIndex = someIterHandHand-1;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].lastAgentHandIndex = someIterAgentHand-1;

	 
	  /////////////
	  // Angle between agents
	  //////////////////

	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentAgentAngleIndex = -1;
	  if(SDI_F->distancesInfo.agents[i].allowAngleComputation){
	    if(someIterAgentAgentAngle < SDI_F->distancesInfo.numAgentAgentAnglesMax){
	      SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentAgentAngleIndex = someIterAgentAgentAngle;
	      updateAngleNew(i,j,SDI_F->distancesInfo.agents[i].orientation,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.agents[j].position,SDI_F->distancesInfo.agentAgentAngles[someIterAgentAgentAngle].index1,SDI_F->distancesInfo.agentAgentAngles[someIterAgentAgentAngle].index2,SDI_F->distancesInfo.agentAgentAngles[someIterAgentAgentAngle].angle);
	      someIterAgentAgentAngle++;
	    }
	    else
	      printf("Too many agent agent angle. Max is %d\n",SDI_F->distancesInfo.numAgentAgentAnglesMax);
	  }
	  if(SDI_F->distancesInfo.agents[j].allowAngleComputation){	   
	    if(someIterAgentAgentAngle < SDI_F->distancesInfo.numAgentAgentAnglesMax){
	      if(SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentAgentAngleIndex == -1)
		SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentAgentAngleIndex = someIterAgentAgentAngle;
	      updateAngleNew(j,i,SDI_F->distancesInfo.agents[j].orientation,SDI_F->distancesInfo.agents[j].position,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.agentAgentAngles[someIterAgentAgentAngle].index1,SDI_F->distancesInfo.agentAgentAngles[someIterAgentAgentAngle].index2,SDI_F->distancesInfo.agentAgentAngles[someIterAgentAgentAngle].angle);
	      someIterAgentAgentAngle++;
	    }
	    else
	      printf("Too many agent agent angle. Max is %d\n",SDI_F->distancesInfo.numAgentAgentAnglesMax);
	  }
	  
	  SDI_F->distancesInfo.numAgentAgentAngles = someIterAgentAgentAngle;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].lastAgentAgentAngleIndex = someIterAgentAgentAngle-1;
	
	  ////////////////////////////
	  // pointing betzeen agents and agent head
	  ///////////////////////////////
	  // head index is agent index : only one head!
	  // arm index same as hand index!

	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHeadPointingIndex = -1;
	  if(SDI_F->distancesInfo.agents[i].allowPointingComputation){
	    for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){
	      if(someIterAgentHeadPointing < SDI_F->distancesInfo.numAgentArmAgentPointingMax){
		if(SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHeadPointingIndex == -1)
		  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHeadPointingIndex = someIterAgentHeadPointing;
		updatePointing( k, headIndex2, SDI_F->distancesInfo.arms[k].armVector, SDI_F->distancesInfo.arms[k].shoulderPosition,SDI_F->distancesInfo.heads[headIndex2].position,SDI_F->distancesInfo.arms[k].armVectorLength,SDI_F->distancesInfo.arms[k].armVectorLengthMax,SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].agentIndex,SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].index,SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].optimalPointingVec , SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].optimalPointingPoint,  SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].curAngleFromOptimalPointingVec,  SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].pointingScore);
		someIterAgentHeadPointing++;
	      }
	      else
		printf("Too many agent agent pointing. Max is %d\n",SDI_F->distancesInfo.numAgentArmAgentPointingMax);
	    }
	  }

	  if(SDI_F->distancesInfo.agents[j].allowPointingComputation){
	    for(int l = firstHandIndex2; l< firstHandIndex2 + numHands2; l++){
	      if(someIterAgentHeadPointing < SDI_F->distancesInfo.numAgentArmAgentPointingMax){
		if(SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHeadPointingIndex == -1)
		  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHeadPointingIndex = someIterAgentHeadPointing;
		updatePointing( l, headIndex, SDI_F->distancesInfo.arms[l].armVector, SDI_F->distancesInfo.arms[l].shoulderPosition,SDI_F->distancesInfo.heads[headIndex].position,SDI_F->distancesInfo.arms[l].armVectorLength,SDI_F->distancesInfo.arms[l].armVectorLengthMax,SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].agentIndex,SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].index,SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].optimalPointingVec , SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].optimalPointingPoint,  SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].curAngleFromOptimalPointingVec,  SDI_F->distancesInfo.agentArmAgentPointing[someIterAgentHeadPointing].pointingScore);
		someIterAgentHeadPointing++;
	      }
	      else
		printf("Too many agent agent pointing. Max is %d\n",SDI_F->distancesInfo.numAgentArmAgentPointingMax);	 
	    }
	  }
	  SDI_F->distancesInfo.numAgentArmAgentPointing = someIterAgentHeadPointing;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].lastAgentHeadPointingIndex = someIterAgentHeadPointing-1;
	}
	else{
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstHandHandIndex = -1;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHandIndex = -1;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentAgentAngleIndex = -1;
	  SDI_F->distancesInfo.agentAgentDists[someIterAgentAgent].firstAgentHeadPointingIndex = -1;
	}	
	someIterAgentAgent++;	       
      }
      else
	printf("Too many agent agent distance. Max is %d\n",SDI_F->distancesInfo.numAgentAgentDistsMax);
    }
  }
  SDI_F->distancesInfo.numAgentAgentDists = someIterAgentAgent;

  ///////////////////////////////
  // agent /  Object distances.
  ///////////////////////////////

  int someIterAgentObject = 0;
  int someIterHandObject = 0; 
  int someIterAgentObjectAngle = 0;
  int someIterAgentObjectPointing = 0;
 
  for(int i = 0; i< numAgents; i++){
    for(int j = 0; j< numObjects; j++){
      if(someIterAgentObject < SDI_F->distancesInfo.numAgentObjectDistsMax){
	updateDistAndMinDist(i,j,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.objects[j].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].index1,SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].index2,SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].curDist,SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].minDist, SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].minDistTime);

	////////////////////////////////////////
	//allow to compute distance involving these agent hand and object
	/////////////////////////////////////////
	if(SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].curDist < distThreshold){
	  firstHandIndex = SDI_F->distancesInfo.agents[i].firstHandIndex;
	  numHands = SDI_F->distancesInfo.agents[i].numHands;
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].firstHandObjectIndex = someIterHandObject;	 

	  for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){
	    if(someIterHandObject < SDI_F->distancesInfo.numHandObjectDistsMax){
	      updateDistAndMinDist(k,j,SDI_F->distancesInfo.hands[k].position,SDI_F->distancesInfo.objects[j].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.handObjectDists[someIterHandObject].index1,SDI_F->distancesInfo.handObjectDists[someIterHandObject].index2,SDI_F->distancesInfo.handObjectDists[someIterHandObject].curDist,SDI_F->distancesInfo.handObjectDists[someIterHandObject].minDist,SDI_F->distancesInfo.handObjectDists[someIterHandObject].minDistTime);
	      someIterHandObject++;
	    }
	    else 
	      printf("Too many hand object distance. Max is %d\n",SDI_F->distancesInfo.numHandObjectDistsMax);
	  }

	  SDI_F->distancesInfo.numHandObjectDists = someIterHandObject;
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].lastHandObjectIndex = someIterHandObject-1;


	  /////////////
	  // Angle between agent and object
	  //////////////////
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].agentObjectAngleIndex = -1;

	  if(SDI_F->distancesInfo.agents[i].allowAngleComputation){
	    if(someIterAgentObjectAngle < SDI_F->distancesInfo.numAgentObjectAnglesMax){
	      SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].agentObjectAngleIndex = someIterAgentObjectAngle;
	      updateAngleNew(i,j,SDI_F->distancesInfo.agents[i].orientation,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.objects[j].position,SDI_F->distancesInfo.agentObjectAngles[someIterAgentObjectAngle].index1,SDI_F->distancesInfo.agentObjectAngles[someIterAgentObjectAngle].index2,SDI_F->distancesInfo.agentObjectAngles[someIterAgentObjectAngle].angle);
	      someIterAgentObjectAngle++;
	    }
	    else
	      printf("Too many AgentObjectAngles. Max is %d\n",SDI_F->distancesInfo.numAgentObjectAnglesMax);
	  }
	  SDI_F->distancesInfo.numAgentObjectAngles = someIterAgentObjectAngle;

	  /////////////
	  // pointing between agent and object
	  //////////////////
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].firstAgentObjectPointingIndex = -1;
	  if(SDI_F->distancesInfo.agents[i].allowPointingComputation){
	    for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){
	      if(someIterAgentObjectPointing < SDI_F->distancesInfo.numAgentArmObjectPointingMax){
		if(SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].firstAgentObjectPointingIndex == -1)
		  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].firstAgentObjectPointingIndex = someIterAgentObjectPointing;
		updatePointing( k, j, SDI_F->distancesInfo.arms[k].armVector, SDI_F->distancesInfo.arms[k].shoulderPosition,SDI_F->distancesInfo.objects[j].position,SDI_F->distancesInfo.arms[k].armVectorLength,SDI_F->distancesInfo.arms[k].armVectorLengthMax,SDI_F->distancesInfo.agentArmObjectPointing[someIterAgentObjectPointing].agentIndex,SDI_F->distancesInfo.agentArmObjectPointing[someIterAgentObjectPointing].index,SDI_F->distancesInfo.agentArmObjectPointing[someIterAgentObjectPointing].optimalPointingVec , SDI_F->distancesInfo.agentArmObjectPointing[someIterAgentObjectPointing].optimalPointingPoint,  SDI_F->distancesInfo.agentArmObjectPointing[someIterAgentObjectPointing].curAngleFromOptimalPointingVec,  SDI_F->distancesInfo.agentArmObjectPointing[someIterAgentObjectPointing].pointingScore);	
		someIterAgentObjectPointing++;
	      }
	      else
		printf("Too many AgentArmObjectPointing. Max is %d\n",SDI_F->distancesInfo.numAgentArmObjectPointingMax);
	    }
	  }

	  SDI_F->distancesInfo.numAgentArmObjectPointing = someIterAgentObjectPointing;
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].lastAgentObjectPointingIndex = someIterAgentObjectPointing-1;
		      
	}
	else{
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].firstHandObjectIndex = -1;
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].agentObjectAngleIndex = -1;
	  SDI_F->distancesInfo.agentObjectDists[someIterAgentObject].firstAgentObjectPointingIndex = -1;
	}
      
	someIterAgentObject++;	 
      }
      else 
	printf("Too many agent object distance. Max is %d\n",SDI_F->distancesInfo.numAgentObjectDistsMax);
    }
  }
  SDI_F->distancesInfo.numAgentObjectDists = someIterAgentObject;

  ///////////////////////////////
  // agent /  Table distances.
  ///////////////////////////////

  int someIterAgentTable = 0;
  int someIterHandTable = 0;
  //int someIterHandTablePoint = 0;
  int someIterAgentTablePoint = 0; 
  int someIterAgentTablePointAngle = 0;  
  int someIterAgentTablePointPointing = 0;
  int someIterAgentTablePointingIntersection = 0;
  int firstTablePointIndex = 0;
  int numTablePoints = 0;
  bool allowSaveHistoryForThisHand;
  for(int i = 0; i< numAgents; i++){
    for(int j = 0; j< numTables; j++){
      if(someIterAgentTable < SDI_F->distancesInfo.numAgentTableDistsMax){
	updateDistAndMinDistToTable(0,i,j,false,false,0,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.tables[j].tableCornersPositions,forceReinitMinDist, aTime,SDI_F->distancesInfo.agentTableDists[someIterAgentTable].index1,SDI_F->distancesInfo.agentTableDists[someIterAgentTable].index2,SDI_F->distancesInfo.agentTableDists[someIterAgentTable].curDist,SDI_F->distancesInfo.agentTableDists[someIterAgentTable].isAbove,SDI_F->distancesInfo.agentTableDists[someIterAgentTable].closestPoint,   SDI_F->distancesInfo.agentTableDists[someIterAgentTable].minDist, SDI_F->distancesInfo.agentTableDists[someIterAgentTable].minDistTime , SDI_F->distancesInfo.agentTableDists[someIterAgentTable].minDistPosition, anInt ,anInt,anInt);


	////////////////////////////////////////
	//allow to compute distance involving these agent hands and table.
	/////////////////////////////////////////
	if(SDI_F->distancesInfo.agentTableDists[someIterAgentTable].curDist < distThreshold){
	  firstHandIndex = SDI_F->distancesInfo.agents[i].firstHandIndex;
	  numHands = SDI_F->distancesInfo.agents[i].numHands;
	  firstTablePointIndex = SDI_F->distancesInfo.tables[i].firstTablePointIndex;
	  numTablePoints = SDI_F->distancesInfo.tables[i].numTablePoints;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstHandTableIndex = someIterHandTable;


	  /////////////
	  // between Agent  and table points if below small threshold
	  ///////////

	  //if it has not been yet initalized put it to the first value

	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointIndex = someIterAgentTablePoint;
	  for(int l = firstTablePointIndex; l< firstTablePointIndex + numTablePoints; l++){
	    if(someIterAgentTablePoint < SDI_F->distancesInfo.numAgentTablePointDistsMax){
	      updateDistAndMinDist(i,l,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.tablePoints[l].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.agentTablePointDists[someIterAgentTablePoint].index1,SDI_F->distancesInfo.agentTablePointDists[someIterAgentTablePoint].index2,SDI_F->distancesInfo.agentTablePointDists[someIterAgentTablePoint].curDist,SDI_F->distancesInfo.agentTablePointDists[someIterAgentTablePoint].minDist,SDI_F->distancesInfo.agentTablePointDists[someIterAgentTablePoint].minDistTime);
	      someIterAgentTablePoint++;
	    }
	    else
	      printf("Too many TablePointDists. Max is %d\n",SDI_F->distancesInfo.numAgentTablePointDistsMax);
	  }

	  SDI_F->distancesInfo.numAgentTablePointDists = someIterAgentTablePoint;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTablePoint].lastAgentTablePointIndex = someIterAgentTablePoint-1;



	  //Initialize value
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstHandTableIndex = -1;

	  for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){
	    if(someIterHandTable < SDI_F->distancesInfo.numHandTableDistsMax){

	      //we save history for this hand only if the general saveHistory bool is true and we allow pointing computation for this arm.
	      allowSaveHistoryForThisHand = false;
	      if(SDI_F->distancesInfo.agents[i].allowPointingComputation)
		allowSaveHistoryForThisHand = saveHistory;

	      updateDistAndMinDistToTable(i,k,j,true,allowSaveHistoryForThisHand,saveHistoryDistanceThreshold,SDI_F->distancesInfo.hands[k].position,SDI_F->distancesInfo.tables[j].tableCornersPositions,forceReinitMinDist, aTime,SDI_F->distancesInfo.handTableDists[someIterHandTable].index1,SDI_F->distancesInfo.handTableDists[someIterHandTable].index2,SDI_F->distancesInfo.handTableDists[someIterHandTable].curDist,SDI_F->distancesInfo.handTableDists[someIterHandTable].isAbove,SDI_F->distancesInfo.handTableDists[someIterHandTable].closestPoint,SDI_F->distancesInfo.handTableDists[someIterHandTable].minDist,SDI_F->distancesInfo.handTableDists[someIterHandTable].minDistTime,SDI_F->distancesInfo.handTableDists[someIterHandTable].minDistPosition,SDI_F->distancesInfo.handTableDists[someIterHandTable].trajectoryIndex,SDI_F->distancesInfo.handTableDists[someIterHandTable].distanceHistoryIndex,SDI_F->distancesInfo.handTableDists[someIterHandTable].timeStepIndex);
	      someIterHandTable ++;
	    }
	    else
	      printf("Too many HandTableDists. Max is %d\n",SDI_F->distancesInfo.numHandTableDistsMax);	    
	  }

	  SDI_F->distancesInfo.numHandTableDists = someIterHandTable;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].lastHandTableIndex = someIterHandTable-1;

	  
	  /////////////
	  // Angle between agent and table points
	  //////////////////
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointAngleIndex = -1;
	  
	  if(SDI_F->distancesInfo.agents[i].allowAngleComputation){
	    SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointAngleIndex = someIterAgentTablePointAngle;
		
	    for(int l = firstTablePointIndex; l< firstTablePointIndex + numTablePoints; l++){
	      if(someIterAgentTablePointAngle < SDI_F->distancesInfo.numAgentTablePointDistsMax){
		updateAngleNew(i,l,SDI_F->distancesInfo.agents[i].orientation,SDI_F->distancesInfo.agents[i].position,SDI_F->distancesInfo.tablePoints[l].position,SDI_F->distancesInfo.agentTablePointAngles[someIterAgentTablePointAngle].index1,SDI_F->distancesInfo.agentTablePointAngles[someIterAgentTablePointAngle].index2,SDI_F->distancesInfo.agentTablePointAngles[someIterAgentTablePointAngle].angle);
		someIterAgentTablePointAngle++;
	      }
	      else
		printf("Too many AgentTablePointDists. Max is %d\n",SDI_F->distancesInfo.numAgentTablePointDistsMax);
	    }
	    SDI_F->distancesInfo.numAgentTablePointDists = someIterAgentTablePointAngle;
	    SDI_F->distancesInfo.agentTableDists[someIterAgentTable].lastAgentTablePointAngleIndex = someIterAgentTablePointAngle-1;
	  }

	  ///////////////////////////////////////////
	  // Pointing between agent and table
	  ///////////////////////////////////////////////
	

	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointPointingIndex = -1;
	  if(SDI_F->distancesInfo.agents[i].allowPointingComputation){	  
	    for(int k = firstHandIndex; k< firstHandIndex + numHands; k++){

	      bool isArmPointingTowardTableBool = isArmPointingTowardTable(0.2,SDI_F->distancesInfo.arms[k].shoulderPosition,SDI_F->distancesInfo.arms[k].armVector,SDI_F->distancesInfo.tables[j].tableCornersPositions,aPoint);
	      if(someIterAgentTablePointingIntersection < SDI_F->distancesInfo.numAgentArmTablePointingIntersectionMax){
		if(SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointingIntersectionIndex == -1)
		  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointingIntersectionIndex = SDI_F->distancesInfo.numAgentArmTablePointingIntersection;
		SDI_F->distancesInfo.agentArmTablePointingIntersection[someIterAgentTablePointingIntersection].index1 = k;
		SDI_F->distancesInfo.agentArmTablePointingIntersection[someIterAgentTablePointingIntersection].index2 = j;
		copyVec(aPoint,SDI_F->distancesInfo.agentArmTablePointingIntersection[someIterAgentTablePointingIntersection].intersection);
		someIterAgentTablePointingIntersection++;
	      }
	      else
		printf("Too many AgentArmTablePointingIntersect. Max is %d\n",SDI_F->distancesInfo.numAgentArmTablePointingIntersectionMax);
	      
		
	      if(isArmPointingTowardTableBool){
		// for(int l = firstTablePointIndex; l< firstTablePointIndex + numTablePoints; l++){
		//   if(someIterAgentTablePointPointing < SDI_F->distancesInfo.numAgentArmTablePointPointingMax){
		//     if(SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointPointingIndex == -1)
		//       SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointPointingIndex = someIterAgentTablePointPointing;
		//     updatePointing( k, l, SDI_F->distancesInfo.arms[k].armVector, SDI_F->distancesInfo.arms[k].shoulderPosition,SDI_F->distancesInfo.tablePoints[l].position,SDI_F->distancesInfo.arms[k].armVectorLength,SDI_F->distancesInfo.arms[k].armVectorLengthMax,SDI_F->distancesInfo.agentArmTablePointPointing[someIterAgentTablePointPointing].agentIndex,SDI_F->distancesInfo.agentArmTablePointPointing[someIterAgentTablePointPointing].index,SDI_F->distancesInfo.agentArmTablePointPointing[someIterAgentTablePointPointing].optimalPointingVec , SDI_F->distancesInfo.agentArmTablePointPointing[someIterAgentTablePointPointing].optimalPointingPoint,  SDI_F->distancesInfo.agentArmTablePointPointing[someIterAgentTablePointPointing].curAngleFromOptimalPointingVec,  SDI_F->distancesInfo.agentArmTablePointPointing[someIterAgentTablePointPointing].pointingScore);	
		//     someIterAgentTablePointPointing++;
		//   }
		//   else
		//     printf("Too many AgentArmTablePointPointing. Max is %d\n",SDI_F->distancesInfo.numAgentArmTablePointPointingMax);
	      }
	    }
	  }
	  SDI_F->distancesInfo.numAgentArmTablePointingIntersection = someIterAgentTablePointingIntersection;
	  SDI_F->distancesInfo.numAgentArmTablePointPointing = someIterAgentTablePointPointing;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].lastAgentTablePointPointingIndex = someIterAgentTablePointPointing-1;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].lastAgentTablePointingIntersectionIndex = someIterAgentTablePointingIntersection-1;      
	}
	else{
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstHandTableIndex = -1;
	  //SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstHandTablePointIndex = -1;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointAngleIndex = -1;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointPointingIndex = -1;
	  SDI_F->distancesInfo.agentTableDists[someIterAgentTable].firstAgentTablePointingIntersectionIndex = -1; 
	}
	
	someIterAgentTable++;	       
      }
      else
	printf("Too many AgentTableDists. Max is %d\n",SDI_F->distancesInfo.numAgentTableDistsMax);

    }
  }
  
  SDI_F->distancesInfo.numAgentTableDists = someIterAgentTable;

  ///////////////////////////////
  // object /  Object distances.
  ///////////////////////////////

  int someIterObjectObject = 0;
  for(int i = 0; i< numObjects; i++){
    for(int j = i+1; j< numObjects; j++){
      if(someIterObjectObject < SDI_F->distancesInfo.numObjectObjectDistsMax){
	updateDistAndMinDist(i,j,SDI_F->distancesInfo.objects[i].position,SDI_F->distancesInfo.objects[j].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.objectObjectDists[someIterObjectObject].index1,SDI_F->distancesInfo.objectObjectDists[someIterObjectObject].index2,SDI_F->distancesInfo.objectObjectDists[someIterObjectObject].curDist,SDI_F->distancesInfo.objectObjectDists[someIterObjectObject].minDist,SDI_F->distancesInfo.objectObjectDists[someIterObjectObject].minDistTime);
	someIterObjectObject++;
      }
      else
	printf("Too many ObjectObjectDists. Max is %d\n",SDI_F->distancesInfo.numObjectObjectDistsMax);
    }
  }
  SDI_F->distancesInfo.numObjectObjectDists  = someIterObjectObject;

  ///////////////////////////////
  // object /  Table distances.
  ///////////////////////////////

  int someIterObjectTable = 0;
  //int someIterObjectTablePoint = 0;  
  for(int i = 0; i< numObjects; i++){
    for(int j = 0; j< numTables; j++){
      if(someIterObjectTable < SDI_F->distancesInfo.numObjectTableDistsMax){
	updateDistAndMinDistToTable(0,i,j,false,false,0,SDI_F->distancesInfo.objects[i].position,SDI_F->distancesInfo.tables[j].tableCornersPositions,forceReinitMinDist, aTime,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].index1,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].index2,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].curDist,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].isAbove,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].closestPoint,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].minDist, SDI_F->distancesInfo.objectTableDists[someIterObjectTable].minDistTime,SDI_F->distancesInfo.objectTableDists[someIterObjectTable].minDistPosition,anInt,anInt,anInt);


	////////////////////////////////////////
	//allow to compute distance to closest table point
	/////////////////////////////////////////
	// if(SDI_F->distancesInfo.objectTableDists[someIterAgentAgent].curDist < distThresholdSmall){
	//   firstTablePointIndex = SDI_F->distancesInfo.tables[i].firstTablePointIndex;
	//   numTablePoints = SDI_F->distancesInfo.tables[i].numTablePoints;
	//   SDI_F->distancesInfo.objectTableDists[someIterObjectTable].firstObjectTablePointIndex = someIterObjectTablePoint;
	// for(int l = firstTablePointIndex; l< firstTablePointIndex + numTablePoints; l++){
	//   updateDistAndMinDist(i,l,SDI_F->distancesInfo.objects[i].position,SDI_F->distancesInfo.tablePoints[l].position,forceReinitMinDist, aTime,SDI_F->distancesInfo.objectTablePointDists[someIterObjectTablePoint].index1,SDI_F->distancesInfo.objectTablePointDists[someIterObjectTablePoint].index2,SDI_F->distancesInfo.objectTablePointDists[someIterObjectTablePoint].curDist,SDI_F->distancesInfo.objectTablePointDists[someIterObjectTablePoint].minDist,SDI_F->distancesInfo.objectTablePointDists[someIterObjectTablePoint].minDistTime);
	//   someIterObjectTablePoint++;
	// }       	 
	//   SDI_F->distancesInfo.objectTableDists[someIterObjectTable].lastObjectTableIndex = someIterObjectTablePoint-1;
	// }
	// else
	//   SDI_F->distancesInfo.objectTableDists[someIterObjectTable].firstObjectTablePointIndex = -1;       

	someIterObjectTable++;	 
      }
      else
	printf("Too many ObjectTableDists. Max is %d\n",SDI_F->distancesInfo.numObjectTableDistsMax);

    }
  }
  SDI_F->distancesInfo.numObjectTableDists = someIterObjectTable;


  // reinitialize distance only once.
  if(forceReinitMinDist)
    SDI_F->distancesInfo.forceReinitMinDist = FALSE;

}

// void computeDistancesAndFillDistanceManagementPoster( void ){
//   int numPositions = SDI_F->distancesInfo.numPositions;
//   HRI_ENTITY * entity;
//   int entityIndex,entityIndexSupport,entityIndexAtDistanceOfSupport,someIter;
//   double someDistance,someDistanceSupport;
//   double x,y,z,x2,y2,z2;
//   SPARK_DIST_ELEM_TYPE type1;
//   SPARK_DIST_ELEM_TYPE type2;
//   //bool belowThreshold = false;
//   // int mainEntityIndex1 = -1;
//   // int mainEntityIndex2 = -1;
//   // int lastMainEntityIndex1 = -1;
//   // int lastMainEntityIndex2 = -1;
//   // int indexElem1 = -1;
//   // int indexElem2 = -1;
//   // bool lastBelowThreshold = false;
//   int iterOnSimpleObjects = 0;
//   int iterOnSupportPoints = 0;
//   int indexForObjectInOccupancyTable = 0;
//   int indexForSupportPointInOccupancyTable = 0;
//   int indexForObjectInPositionTable = 0;
//   int indexForSupportPointInPositionTable = 0;
//   bool saveDistance = true;
//   bool computeDistance = true;
    
//   //////////////////////
//   // update positions
//   ///////////////////////

//   //update positions for those that are considering to be changing.
//   //all except tables
//   for(int i = 0; i< numPositions; i++){
    
//     if( SDI_F->distancesInfo.positions[i].elemType != SPARK_DIST_SUPPORT_POINT){
//       if( SDI_F->distancesInfo.positions[i].elemType == SPARK_DIST_SIMPLE_OBJECT){
// 	SDI_F->distancesInfo.positions[i].typeIter = iterOnSimpleObjects;
// 	iterOnSimpleObjects++;
//       }
      

//       entityIndex = SDI_F->distancesInfo.positions[i].entityIndex;
//       entity = gEntities->entities[entityIndex];
      
//       if((entity->type == HRI_OBJECT_PART) || (entity->type == HRI_AGENT_PART)) {
//         x = (entity->partPt->BB.xmax + entity->partPt->BB.xmin)/2;
// 	y = (entity->partPt->BB.ymax + entity->partPt->BB.ymin)/2;
// 	//we want table top
// 	if( SDI_F->distancesInfo.positions[i].elemType == SPARK_DIST_SUPPORT)
// 	  z = entity->partPt->BB.zmax;
// 	else
// 	  z = (entity->partPt->BB.zmax + entity->partPt->BB.zmin)/2;
//       }
//       else {
// 	x = (entity->robotPt->BB.xmax + entity->robotPt->BB.xmin)/2;
// 	y = (entity->robotPt->BB.ymax + entity->robotPt->BB.ymin)/2;
// 	//we want table top
// 	if( SDI_F->distancesInfo.positions[i].elemType == SPARK_DIST_SUPPORT)
// 	  z = entity->robotPt->BB.zmax;
// 	else
// 	  z = (entity->robotPt->BB.zmax + entity->robotPt->BB.zmin)/2;

//       }
//       SDI_F->distancesInfo.positions[i].elemPosition.x = x;
//       SDI_F->distancesInfo.positions[i].elemPosition.y = y;
//       SDI_F->distancesInfo.positions[i].elemPosition.z = z;
//     }
//     else{
//       SDI_F->distancesInfo.positions[i].typeIter = iterOnSupportPoints;
//       iterOnSupportPoints++;
//     }

//   }
    
//   ///////////////////////////////////
//   // initialize occupancy scores
//   //////////////////////////////////
//   SDI_F->distancesInfo.numOccupancies = SDI_F->distancesInfo.numSimpleObjects + SDI_F->distancesInfo.numSupportPoints;
//   if( SDI_F->distancesInfo.numOccupancies > SPARK_DISTANCES_INFO_NUM_OCCUPANCIES_MAX){
//     printf("Too many occupancies in distances info poster. Max is %d\n",SPARK_DISTANCES_INFO_NUM_OCCUPANCIES_MAX);
//     return;
//   }
//   for(int i = 0; i < SDI_F->distancesInfo.numOccupancies ; i++)
//     SDI_F->distancesInfo.occupancies[i].minDistance = -1.0;

//   /////////////////
//   // compute distances that are computed systematically
//   ///////////////////////

//   //compute distance between agent and agent

//   //compute distance between agent and table

//   //compute distance between agent and object

//   //compute distance between object and table
//   someIter = 0;
//   for(int i = 0; i< numPositions; i++){
//     type1 = SDI_F->distancesInfo.positions[i].elemType;
//       x = SDI_F->distancesInfo.positions[i].elemPosition.x;
//       y = SDI_F->distancesInfo.positions[i].elemPosition.y;
//       z = SDI_F->distancesInfo.positions[i].elemPosition.z;

//       for(int j = i+1; j< numPositions; j++){
// 	type2 = SDI_F->distancesInfo.positions[j].elemType;
	
// 	//compute all distances except distances between support_point and (support_point or support or agent)
// 	if( !((type1 == SPARK_DIST_SUPPORT_POINT) && ((type2 == SPARK_DIST_SUPPORT_POINT) || (type2 == SPARK_DIST_SUPPORT))) && !((type2 == SPARK_DIST_SUPPORT_POINT) && ((type1 == SPARK_DIST_SUPPORT_POINT) || (type1 == SPARK_DIST_SUPPORT)))){
// 	  if( someIter == SPARK_DISTANCES_INFO_NUM_DISTANCES_MAX){
// 	    printf("Too many distances in distances info poster. Max is %d\n",SPARK_DISTANCES_INFO_NUM_DISTANCES_MAX);
// 	    return;
// 	  }
// 	  //optimization to avoid systematic computation for support_point.
// 	  //was it already too far from support?
// 	  //!!!!!!!!!!table should be at the end of the list so that it is relevant!!!!!!!!!!!!!!!
	  
// 	  computeDistance = true;
// 	  if(type1 == SPARK_DIST_SUPPORT_POINT) {
// 	    if( (entityIndexSupport == SDI_F->distancesInfo.positions[i].mainEntityIndex) && (entityIndexAtDistanceOfSupport == SDI_F->distancesInfo.positions[j].entityIndex) && (someDistanceSupport > SDI_F->distancesInfo.distFromTableThreshold)) 
// 	      	  computeDistance = false;
// 	  }
// 	  if(type2 == SPARK_DIST_SUPPORT_POINT) {
// 	    if( (entityIndexSupport == SDI_F->distancesInfo.positions[j].mainEntityIndex) && (entityIndexAtDistanceOfSupport == SDI_F->distancesInfo.positions[i].entityIndex) && (someDistanceSupport > SDI_F->distancesInfo.distFromTableThreshold)) 
// 	      	  computeDistance = false;
// 	  }

// 	  if ( computeDistance ) {
// 	    x2 = SDI_F->distancesInfo.positions[j].elemPosition.x;
// 	    y2 = SDI_F->distancesInfo.positions[j].elemPosition.y;
// 	    z2 = SDI_F->distancesInfo.positions[j].elemPosition.z;    
// 	    someDistance = D3D(x,y,z,x2,y2,z2);
// 	  }

// 	  if(computeDistance){
// 	    //optimization to avoid systematic computation for support_point.
// 	    //was it already too far from support?
// 	    if(type1 == SPARK_DIST_SUPPORT) {
// 	      entityIndexSupport = SDI_F->distancesInfo.positions[i].mainEntityIndex;
// 	      entityIndexAtDistanceOfSupport = SDI_F->distancesInfo.positions[j].entityIndex;
// 	      someDistanceSupport = someDistance; 
// 	    }
// 	    if(type2 == SPARK_DIST_SUPPORT) {
// 	      entityIndexSupport = SDI_F->distancesInfo.positions[j].mainEntityIndex;
// 	      entityIndexAtDistanceOfSupport = SDI_F->distancesInfo.positions[i].entityIndex;
// 	      someDistanceSupport = someDistance; 
// 	    }

// 	    saveDistance = true;
// 	    if( (type1 == SPARK_DIST_SUPPORT_POINT) || (type2 == SPARK_DIST_SUPPORT_POINT)){
// 	      //printf("%d %d %f\n",type1,type2,someDistance);
// 	      if(someDistance > SDI_F->distancesInfo.distFromTableThreshold)
// 		saveDistance = false;
// 	    }
// 	    if(saveDistance){
// 	      SDI_F->distancesInfo.distances[someIter].indexElem1 = i;
// 	      SDI_F->distancesInfo.distances[someIter].indexElem2 = j;
// 	      SDI_F->distancesInfo.distances[someIter].distance = someDistance;

// 	      //update occupancy.
// 	      //first the simple objects then the support points
// 	      //what is closest support_point for all objects.
// 	      //what is closest object for all support points.
// 	      if( ( (type1 == SPARK_DIST_SUPPORT_POINT) && (type2 == SPARK_DIST_SIMPLE_OBJECT) ) || ( (type2 == SPARK_DIST_SUPPORT_POINT) && (type1 == SPARK_DIST_SIMPLE_OBJECT) ) ){
// 		if( (type1 == SPARK_DIST_SUPPORT_POINT) && (type2 == SPARK_DIST_SIMPLE_OBJECT) ){
// 		  indexForObjectInOccupancyTable = SDI_F->distancesInfo.positions[j].typeIter;
// 		  indexForSupportPointInOccupancyTable = SDI_F->distancesInfo.numSimpleObjects + SDI_F->distancesInfo.positions[i].typeIter;
// 		  indexForObjectInPositionTable = j;
// 		  indexForSupportPointInPositionTable = i;
// 		}
// 		else if ( (type2 == SPARK_DIST_SUPPORT_POINT) && (type1 == SPARK_DIST_SIMPLE_OBJECT) ){
// 		  indexForObjectInOccupancyTable = SDI_F->distancesInfo.positions[i].typeIter;
// 		  indexForSupportPointInOccupancyTable = SDI_F->distancesInfo.numSimpleObjects + SDI_F->distancesInfo.positions[j].typeIter;
// 		  indexForObjectInPositionTable = i;
// 		  indexForSupportPointInPositionTable = j;
// 		}
// 		//printf("%d %d %d %d %f %f %f\n",indexForObjectInOccupancyTable,indexForSupportPointInOccupancyTable,indexForObjectInPositionTable,indexForSupportPointInPositionTable,someDistance,SDI_F->distancesInfo.occupancies[indexForObjectInOccupancyTable].minDistance,SDI_F->distancesInfo.occupancies[indexForSupportPointInOccupancyTable].minDistance);
// 		if( (SDI_F->distancesInfo.occupancies[indexForObjectInOccupancyTable].minDistance < 0.0) || (SDI_F->distancesInfo.occupancies[indexForObjectInOccupancyTable].minDistance > someDistance) ){
// 		  SDI_F->distancesInfo.occupancies[indexForObjectInOccupancyTable].indexElem1 = indexForObjectInPositionTable;  
// 		  SDI_F->distancesInfo.occupancies[indexForObjectInOccupancyTable].indexElem2 = indexForSupportPointInPositionTable;
// 		  SDI_F->distancesInfo.occupancies[indexForObjectInOccupancyTable].minDistance = someDistance;		
// 		}
// 		if( (SDI_F->distancesInfo.occupancies[indexForSupportPointInOccupancyTable].minDistance < 0.0) || (SDI_F->distancesInfo.occupancies[indexForSupportPointInOccupancyTable].minDistance > someDistance) ){
// 		  SDI_F->distancesInfo.occupancies[indexForSupportPointInOccupancyTable].indexElem1 = indexForSupportPointInPositionTable;  
// 		  SDI_F->distancesInfo.occupancies[indexForSupportPointInOccupancyTable].indexElem2 = indexForObjectInPositionTable;
// 		  SDI_F->distancesInfo.occupancies[indexForSupportPointInOccupancyTable].minDistance = someDistance;
// 		}
// 	      }
// 	      someIter++;
// 	    }	  
// 	  }
// 	}
//       } 
//   }
//   SDI_F->distancesInfo.numDistances = someIter;

//   //Angles.
//   updateAngles();
// }

ACTIVITY_EVENT
sparkDistanceManagementStart(int *report)
{
  // SDI_F->distancesInfo.distAgentAgentThreshold = 2.0;
  // SDI_F->distancesInfo.distAgentObjectThreshold = 0.5;
  // SDI_F->distancesInfo.distAgentTableThreshold = 0.5;
  // SDI_F->distancesInfo.distObjectTableThreshold = 0.1;
  // SDI_F->distancesInfo.distFromTableThreshold = 2.0;
  SDI_F->distancesInfo.tableStep = 0.25;
 

  SDI_F->distancesInfo.distThreshold = 1.0;
  SDI_F->distancesInfo.distThresholdSmall = 0.5;
  SDI_F->distancesInfo.saveHistory = FALSE;  
  SDI_F->distancesInfo.saveHistoryDistanceThreshold = 0.8;

  SDI_F->distancesInfo.forceReinitMinDist = FALSE;
  SDI_F->distancesInfo.checkArmVectorLengthMax = FALSE;
  SDI_F->distancesInfo.reinitArmVectorLengthMax = FALSE;
  SDI_F->distancesInfo.forceUpdateTablesPosition = FALSE;
  SDI_F->distancesInfo.initialTime = getTimeInSecondMilisecond();



  SDI_F->distancesInfo.numAgents = 0;
  SDI_F->distancesInfo.numAgentsMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX;

  SDI_F->distancesInfo.numTables = 0;
  SDI_F->distancesInfo.numTablesMax = SPARK_DISTANCES_INFO_NUM_TABLES_MAX;

  SDI_F->distancesInfo.numObjects = 0;
  SDI_F->distancesInfo.numObjectsMax = SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX;

  SDI_F->distancesInfo.numHands = 0;
  SDI_F->distancesInfo.numHandsMax = 2*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX;
  //numArms == numHands

  SDI_F->distancesInfo.numHeads = 0;
  SDI_F->distancesInfo.numHeadsMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX;

  SDI_F->distancesInfo.numTablePoints = 0;
  SDI_F->distancesInfo.numTablePointsMax = SPARK_DISTANCES_INFO_NUM_TABLE_POINTS_MAX;

  SDI_F->distancesInfo.numAgentAgentDists = 0;
  SDI_F->distancesInfo.numAgentAgentDistsMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*(SPARK_DISTANCES_INFO_NUM_AGENTS_MAX-1)/2;

  SDI_F->distancesInfo.numAgentObjectDists = 0;
  SDI_F->distancesInfo.numAgentObjectDistsMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX;

  SDI_F->distancesInfo.numAgentTableDists = 0;
  SDI_F->distancesInfo.numAgentTableDistsMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLES_MAX;

  SDI_F->distancesInfo.numObjectTableDists = 0;
  SDI_F->distancesInfo.numObjectTableDistsMax = SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLES_MAX;

  SDI_F->distancesInfo.numAgentTablePointDists = 0;
  SDI_F->distancesInfo.numAgentTablePointDistsMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLE_POINTS_MAX/2;

  SDI_F->distancesInfo.numAgentHandDists = 0;
  SDI_F->distancesInfo.numAgentHandDistsMax = 2*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*(SPARK_DISTANCES_INFO_NUM_AGENTS_MAX-1);

  SDI_F->distancesInfo.numHandHandDists = 0;
  SDI_F->distancesInfo.numHandHandDistsMax = 8*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*(SPARK_DISTANCES_INFO_NUM_AGENTS_MAX-1);

  SDI_F->distancesInfo.numObjectObjectDists = 0;
  SDI_F->distancesInfo.numObjectObjectDistsMax = SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX*(SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX-1)/2;

  SDI_F->distancesInfo.numHandObjectDists = 0;
  SDI_F->distancesInfo.numHandObjectDistsMax = 2*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX;


  SDI_F->distancesInfo.numHandTableDists = 0;
  SDI_F->distancesInfo.numHandTableDistsMax = 2*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLES_MAX;  

  SDI_F->distancesInfo.numAgentAgentAngles = 0;
  SDI_F->distancesInfo.numAgentAgentAnglesMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*(SPARK_DISTANCES_INFO_NUM_AGENTS_MAX-1)/2;

  SDI_F->distancesInfo.numAgentObjectAngles = 0;
  SDI_F->distancesInfo.numAgentObjectAnglesMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX;

  SDI_F->distancesInfo.numAgentTablePointAngles = 0;
  SDI_F->distancesInfo.numAgentTablePointAnglesMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLE_POINTS_MAX/2;
  
  SDI_F->distancesInfo.numAgentArmAgentPointing = 0;
  SDI_F->distancesInfo.numAgentArmAgentPointingMax = 2*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*(SPARK_DISTANCES_INFO_NUM_AGENTS_MAX-1);

  SDI_F->distancesInfo.numAgentArmObjectPointing = 0;
  SDI_F->distancesInfo.numAgentArmObjectPointingMax = 2*SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX;

  SDI_F->distancesInfo.numAgentArmTablePointPointing = 0;
  SDI_F->distancesInfo.numAgentArmTablePointPointingMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLE_POINTS_MAX;

  SDI_F->distancesInfo.numAgentArmTablePointingIntersection = 0;
  SDI_F->distancesInfo.numAgentArmTablePointingIntersectionMax = SPARK_DISTANCES_INFO_NUM_AGENTS_MAX*SPARK_DISTANCES_INFO_NUM_TABLES_MAX*2;

  //initialize histories arrays
  for(int i = 0; i< SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX; i++){
    SDI_F->distancesInfo.trajectories[i].agentIndex = -1;
    SDI_F->distancesInfo.trajectories[i].handIndex = -1;
    SDI_F->distancesInfo.trajectories[i].entityIndex = -1;
    SDI_F->distancesInfo.trajectories[i].curTimeStepIndex = -1;

    SDI_F->distancesInfo.distanceHistories[i].agentIndex = -1;
    SDI_F->distancesInfo.distanceHistories[i].handIndex = -1;
    SDI_F->distancesInfo.distanceHistories[i].entityIndex = -1;
    SDI_F->distancesInfo.distanceHistories[i].curTimeStepIndex = -1;
  }
    
  return EXEC;
}

ACTIVITY_EVENT
sparkDistanceManagementMain(int *report)
{
  /// time assessment
  double timeStart;
  getRequestTimeStart(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart);

  computeDistancesAndFillDistanceManagementPoster2();
  publishDistancesInfoPoster();
  
  trackRequestTime(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart,SDI_F->requestTimeInfo.printLoopRequestExecutionTimeDistanceInfoIndex);

  return EXEC;
}



ACTIVITY_EVENT
sparkUpdateEntityInDistanceManagementStart(SPARK_UPDATE_ENTITY_IN_DISTANCES_INFO_INPUT_PARAMS *entityInDistanceManagementUpdateInput,int *report)
{
  //manage possible threshold update
  int modifyParameterCommand = entityInDistanceManagementUpdateInput->modifyParameterCommand;




  if(modifyParameterCommand > -1){
    if(modifyParameterCommand == 0){
       SDI_F->distancesInfo.tableStep = entityInDistanceManagementUpdateInput->doubleParameterValue;
       printf("DistanceManagement table step value set to %f\n",entityInDistanceManagementUpdateInput->doubleParameterValue);
    }
    else if(modifyParameterCommand == 1){
      SDI_F->distancesInfo.distThreshold = entityInDistanceManagementUpdateInput->doubleParameterValue;
      printf("DistanceManagement distThreshold value set to %f\n",entityInDistanceManagementUpdateInput->doubleParameterValue);
    }
    else if(modifyParameterCommand == 2){
      SDI_F->distancesInfo.distThresholdSmall = entityInDistanceManagementUpdateInput->doubleParameterValue; 
      printf("DistanceManagement distThresholdSmall value set to %f\n",entityInDistanceManagementUpdateInput->doubleParameterValue);
    }
    else if(modifyParameterCommand == 3){
      if(SDI_F->distancesInfo.saveHistory){
	SDI_F->distancesInfo.saveHistory = FALSE;  
	printf("Stop saving history\n");
      }
      else{
	SDI_F->distancesInfo.saveHistory = TRUE;  
	SDI_F->distancesInfo.saveHistoryDistanceThreshold = entityInDistanceManagementUpdateInput->doubleParameterValue;
	printf("Start saving history with saveHistoryDistanceThreshold value set to %f\n",entityInDistanceManagementUpdateInput->doubleParameterValue);
      }
    }
    else if(modifyParameterCommand == 4){
      SDI_F->distancesInfo.forceReinitMinDist = TRUE;
      printf("Reinit minDist\n");
     }
    else if(modifyParameterCommand == 5){
      SDI_F->distancesInfo.checkArmVectorLengthMax = TRUE;
      printf("Check arm vector length\n");
    }
    else if(modifyParameterCommand == 6){
      SDI_F->distancesInfo.reinitArmVectorLengthMax = TRUE;
      printf("reinit arm vector length\n");
    }
    else if(modifyParameterCommand == 7){
      SDI_F->distancesInfo.forceUpdateTablesPosition = TRUE; 
      printf("force table position update\n");
    }
   else if(modifyParameterCommand == 8){
     // allow to compute pointing.
     int indexAgent = entityInDistanceManagementUpdateInput->intParameterValue;
     if(indexAgent < SPARK_DISTANCES_INFO_NUM_AGENTS_MAX){
       if(SDI_F->distancesInfo.agents[indexAgent].allowPointingComputation){
	 SDI_F->distancesInfo.agents[indexAgent].allowPointingComputation = FALSE;
	 printf("Stop computing pointing for agent %d\n",indexAgent);
       }
       else{
	 SDI_F->distancesInfo.agents[indexAgent].allowPointingComputation = TRUE;
	 printf("Start computing pointing for agent %d\n",indexAgent);
       }
     }
   }
   else if(modifyParameterCommand == 9){
     // allow to compute pointing.
     int indexAgent = entityInDistanceManagementUpdateInput->intParameterValue;
     if(indexAgent < SPARK_DISTANCES_INFO_NUM_AGENTS_MAX){
       if(SDI_F->distancesInfo.agents[indexAgent].allowGestureComputation){
	 SDI_F->distancesInfo.agents[indexAgent].allowGestureComputation = FALSE;
	 printf("Stop computing gesture for agent %d\n",indexAgent);
       }
       else{
	 SDI_F->distancesInfo.agents[indexAgent].allowGestureComputation = TRUE;
	 printf("Start computing gesture for agent %d\n",indexAgent);
       }
     }
   }
   else if(modifyParameterCommand == 10){
     int trajIndex = entityInDistanceManagementUpdateInput->intParameterValue;
     if(trajIndex < SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX){
       printf("Delete hand trajectory with index %d\n",trajIndex);
       SDI_F->distancesInfo.trajectories[trajIndex].agentIndex = -1;
       SDI_F->distancesInfo.trajectories[trajIndex].handIndex = -1;
       SDI_F->distancesInfo.trajectories[trajIndex].entityIndex = -1;
     }
   }

   else{
      *report = S_spark_UNMANAGED_THRESHOLD_INDEX;
      return ETHER;
    }
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkUpdateEntityInDistanceManagementMain(SPARK_UPDATE_ENTITY_IN_DISTANCES_INFO_INPUT_PARAMS *entityInDistanceManagementUpdateInput, int *report)
{
  int e_i;
  bool addOrUpdate = false;
  bool isAlreadyPresent = false;
  int modifyParameterCommand = entityInDistanceManagementUpdateInput->modifyParameterCommand;
  double doubleParameterValue = entityInDistanceManagementUpdateInput->doubleParameterValue;
  int intParameterValue = entityInDistanceManagementUpdateInput->intParameterValue;

  // Get input element index in entity array
  for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
    if (!strcmp(entityInDistanceManagementUpdateInput->entityName.name, gEntities->entities[e_i]->robotPt->name)){
      break;
    }
  }  
  if( e_i == gEntities->entities_nb) {
    *report = S_spark_ENTITY_NOT_FOUND;
    return ETHER;
  }

  //do we add/update or delete this entity
  if(entityInDistanceManagementUpdateInput->addEntity == GEN_TRUE){
    addOrUpdate = true;
  }

  // Look for entity in distance management entity table
  isAlreadyPresent = checkIsPresentObjectEntity(e_i);
  
  //update
  if(addOrUpdate && isAlreadyPresent){
    deleteEntityInDistanceManagement(e_i);
    if(!addEntityInDistanceManagement(e_i,modifyParameterCommand, doubleParameterValue, intParameterValue,entityInDistanceManagementUpdateInput->baseJointName,entityInDistanceManagementUpdateInput->shoulderJointName0,entityInDistanceManagementUpdateInput->shoulderJointName1)){
      *report = S_spark_IMPOSSIBLE_TO_ADD_ENTITY;
      return ETHER;
    }
  }


  //add
  else if (addOrUpdate && !isAlreadyPresent){
    if(!addEntityInDistanceManagement(e_i,modifyParameterCommand, doubleParameterValue, intParameterValue,entityInDistanceManagementUpdateInput->baseJointName,entityInDistanceManagementUpdateInput->shoulderJointName0,entityInDistanceManagementUpdateInput->shoulderJointName1)){
      *report = S_spark_IMPOSSIBLE_TO_ADD_ENTITY;
      return ETHER;
    }
  }

  //delete
  else if (!addOrUpdate && isAlreadyPresent){
    // update array by deleting the line of the entity to delete
    deleteEntityInDistanceManagement(e_i);    
  }

  //It means deleting an unpresent entity : nothing to do!
  else{
    //*report = S_spark_ENTITY_NOT_ALREADY_MANAGED;
    return ETHER;
  }
}
  
/* ------------------------------------------------------------- */
/* ---------  Visualisation Poster  ------------------- */
/* ------------------------------------------------------------- */

void publishVisuInfoPoster( void )
{ 
  sparkVisuInfovisualizationsInfoPosterWrite(SPARK_VISUINFO_POSTER_ID, &SDI_F->visualizationsInfo);
}



int UpdateSomeVisuInfo(  GEN_BOOL addVisuInfo , SPARK_VISU_INFO visuInfo ){
  int numVisuInfo = SDI_F->visualizationsInfo.numVisusInfo;
  bool startShiftingVisuInPoster = false;

  if(addVisuInfo == GEN_TRUE){
    //check if these ids is already used
    int newIndex = numVisuInfo;
    for(int i=0; i<SDI_F->visualizationsInfo.numVisusInfo; i++) {
      if( (SDI_F->visualizationsInfo.visusInfos[i].createrId == visuInfo.createrId) &&
	  (SDI_F->visualizationsInfo.visusInfos[i].createrVisuId == visuInfo.createrVisuId)){
	newIndex = i;
	break;
      }
    }

    //try add a visu info.
    if( (visuInfo.type > -1) && (visuInfo.type < SPARK_VISU_INFO_TYPE_ENUM_MAX)){
      if((numVisuInfo < SPARK_VISU_NUM_MAX)||(newIndex != numVisuInfo)){
	SDI_F->visualizationsInfo.visusInfos[newIndex].isVisuActive = 1;
	copyVec(visuInfo.point1,SDI_F->visualizationsInfo.visusInfos[newIndex].point1);
	copyVec(visuInfo.point2,SDI_F->visualizationsInfo.visusInfos[newIndex].point2);
	SDI_F->visualizationsInfo.visusInfos[newIndex].r = visuInfo.r;
	SDI_F->visualizationsInfo.visusInfos[newIndex].g = visuInfo.g;
	SDI_F->visualizationsInfo.visusInfos[newIndex].b = visuInfo.b;
	SDI_F->visualizationsInfo.visusInfos[newIndex].opacity = visuInfo.opacity;
	SDI_F->visualizationsInfo.visusInfos[newIndex].radius = visuInfo.radius;
	SDI_F->visualizationsInfo.visusInfos[newIndex].length1 = visuInfo.length1;
	SDI_F->visualizationsInfo.visusInfos[newIndex].length2 = visuInfo.length2;
	SDI_F->visualizationsInfo.visusInfos[newIndex].createrId = visuInfo.createrId;      
	SDI_F->visualizationsInfo.visusInfos[newIndex].createrVisuId = visuInfo.createrVisuId;
	SDI_F->visualizationsInfo.visusInfos[newIndex].type = visuInfo.type;	
	if(newIndex == numVisuInfo)
	  SDI_F->visualizationsInfo.numVisusInfo++;
      }
      else{
	return S_spark_TOO_MANY_VISU_INFO;
      }
    }
    else{
      return S_spark_UNKNOWN_VISU_TYPE;
    } 
  }
  else{
    //find tje visu info to be deleted
    for(int i=0; i<SDI_F->visualizationsInfo.numVisusInfo; i++) {
      if(startShiftingVisuInPoster){	
	SDI_F->visualizationsInfo.visusInfos[i-1].isVisuActive = SDI_F->visualizationsInfo.visusInfos[i].isVisuActive;
	copyVec(SDI_F->visualizationsInfo.visusInfos[i].point1,SDI_F->visualizationsInfo.visusInfos[i-1].point1);
	copyVec(SDI_F->visualizationsInfo.visusInfos[i].point2,SDI_F->visualizationsInfo.visusInfos[i-1].point2);
	SDI_F->visualizationsInfo.visusInfos[i-1].r = SDI_F->visualizationsInfo.visusInfos[i].r;
	SDI_F->visualizationsInfo.visusInfos[i-1].g = SDI_F->visualizationsInfo.visusInfos[i].g;
	SDI_F->visualizationsInfo.visusInfos[i-1].b = SDI_F->visualizationsInfo.visusInfos[i].b;
	SDI_F->visualizationsInfo.visusInfos[i-1].opacity = SDI_F->visualizationsInfo.visusInfos[i].opacity;
	SDI_F->visualizationsInfo.visusInfos[i-1].radius = SDI_F->visualizationsInfo.visusInfos[i].radius;
	SDI_F->visualizationsInfo.visusInfos[i-1].length1 = SDI_F->visualizationsInfo.visusInfos[i].length1;
	SDI_F->visualizationsInfo.visusInfos[i-1].length2 = SDI_F->visualizationsInfo.visusInfos[i].length2;
	SDI_F->visualizationsInfo.visusInfos[i-1].createrId = SDI_F->visualizationsInfo.visusInfos[i].createrId;      
	SDI_F->visualizationsInfo.visusInfos[i-1].createrVisuId = SDI_F->visualizationsInfo.visusInfos[i].createrVisuId;
	SDI_F->visualizationsInfo.visusInfos[i-1].type = SDI_F->visualizationsInfo.visusInfos[i].type;	
      }
      if((SDI_F->visualizationsInfo.visusInfos[i].createrId == visuInfo.createrId) && (SDI_F->visualizationsInfo.visusInfos[i].createrVisuId == visuInfo.createrVisuId)){
	startShiftingVisuInPoster = true;
      }
    }
    if(startShiftingVisuInPoster){
      SDI_F->visualizationsInfo.numVisusInfo--;
      SDI_F->visualizationsInfo.visusInfos[SDI_F->visualizationsInfo.numVisusInfo].isVisuActive = 0;
    }
    else{
      return S_spark_VISU_INFO_NOT_ALREADY_HERE;
    }
  }
  return -5;
}

int getCreaterVisuIdFromAgentVisuReachabilityIndex( int agentIndex , int insideAgentIndex){
  return SPARK_VISU_REACHABILITY_BY_AGENT_MAX*agentIndex+insideAgentIndex;
}

void getAgentVisuReachabilityIndexFromCreaterVisuId( int visuIndex , int &agentIndex , int &insideAgentIndex){
  agentIndex = visuIndex/SPARK_VISU_REACHABILITY_BY_AGENT_MAX;
  insideAgentIndex = visuIndex - SPARK_VISU_REACHABILITY_BY_AGENT_MAX*agentIndex;
}


void CheckVisuInfoForReachabilityPosition( void){
  if(SDI_F->visuInfoManagement.showReachability){
    
    int maxReachabilityIndex = SPARK_VISU_REACHABILITY_BY_AGENT_MAX*SPARK_VISU_AGENT_MAX;
    SPARK_3D_COORD entityReachabilityVisuForAgentPosition;
    int agentIndex;
    int insideAgentIndex;
 
    int numUpdate = 0;
    int entityIndex = -1;

   
    for(int i=0; i<SDI_F->visualizationsInfo.numVisusInfo; i++) {
      //is it a reachability visu index : createrId == 0 and createrVisuId < SPARK_VISU_REACHABILITY_BY_AGENT_MAX*SPARK_VISU_AGENT_MAX
      if( (SDI_F->visualizationsInfo.visusInfos[i].createrId == 0) &&
	  (SDI_F->visualizationsInfo.visusInfos[i].createrVisuId < maxReachabilityIndex)){
	
	getAgentVisuReachabilityIndexFromCreaterVisuId( SDI_F->visualizationsInfo.visusInfos[i].createrVisuId , agentIndex , insideAgentIndex);
	entityIndex = SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][insideAgentIndex];
	// printf("checking entity position for index : %d createrVisuId %d agent id %d , insideAgent id %d entity %d\n",i,SDI_F->visualizationsInfo.visusInfos[i].createrVisuId,agentIndex,insideAgentIndex,entityIndex);
	if(entityIndex > -1){
	  ///get points where visu should be for this entity and agent
	  //compare it to the value that is in the poster.
	  createVec(gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[0][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].x,gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[1][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].y,gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[2][3]+SDI_F->visuInfoManagement.verticalOffSet.z,entityReachabilityVisuForAgentPosition);
	  if(getDistanceBetweenPoints(entityReachabilityVisuForAgentPosition,SDI_F->visualizationsInfo.visusInfos[i].point1) > SDI_F->visuInfoManagement.distMaxBeforeUpdate){
	    copyVec(entityReachabilityVisuForAgentPosition,SDI_F->visualizationsInfo.visusInfos[i].point1);
	    //Also update radius and opacity in case it has changed.
	    SDI_F->visualizationsInfo.visusInfos[i].radius = SDI_F->visuInfoManagement.radius;
	    SDI_F->visualizationsInfo.visusInfos[i].opacity = SDI_F->visuInfoManagement.opacity;
	    numUpdate++;
	  }	    
	}
      }
    }
    if(numUpdate > 0)
      publishVisuInfoPoster();
  }
}

int UpdateSomeVisuInfoForReachability( int agentIndex,int entityIndex , bool isReachable ){
  if(SDI_F->visuInfoManagement.showReachability){
    
    if(agentIndex < SPARK_VISU_AGENT_MAX){
      int isFreeIndex = -1;
      int existingIndex = -1;
      GEN_BOOL addVisuInfo;
      SPARK_VISU_INFO visuInfo;
      bool updateVisuInfo = false;


      for(int i = 0; i < SPARK_VISU_REACHABILITY_BY_AGENT_MAX ; i++){
	if(SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][i] == entityIndex)
	  existingIndex = i;
	if(SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][i] == -1)
	  isFreeIndex = i;
      }
    
      // add visualisation if 
      if(isReachable){
	if(existingIndex == -1){
	  if(isFreeIndex > -1){
	    addVisuInfo = GEN_TRUE;
	    updateVisuInfo = true;
	    visuInfo.isVisuActive = 1;
	    visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuReachabilityIndex(agentIndex,isFreeIndex);
	    SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][isFreeIndex] = entityIndex;
	  }
	  else
	    printf("no free index to add reachability visu for agent %d entity %d\n",agentIndex,entityIndex);
	}
      }
      else{
	if(existingIndex > -1){
	  addVisuInfo = GEN_FALSE;
	  updateVisuInfo = true;
	  visuInfo.isVisuActive = 0;
	  visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuReachabilityIndex(agentIndex,existingIndex);
	  SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][existingIndex] = -1;
	}      
      }

      if(updateVisuInfo){	
	visuInfo.point1.x = gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[0][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].x;
	visuInfo.point1.y = gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[1][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].y;
	visuInfo.point1.z = gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[2][3]+SDI_F->visuInfoManagement.verticalOffSet.z;

	visuInfo.r = SDI_F->visuInfoManagement.r[agentIndex];
	visuInfo.g = SDI_F->visuInfoManagement.g[agentIndex];
	visuInfo.b = SDI_F->visuInfoManagement.b[agentIndex];
	visuInfo.opacity = 1.0;
	visuInfo.radius = 0.04;
	visuInfo.createrId = 0;      
	visuInfo.type = SPARK_VISU_INFO_SPHERE;
	UpdateSomeVisuInfo( addVisuInfo , visuInfo);
	printf("updating reachability value %d visu for agent %d entity %d visu index is %d\n",isReachable,agentIndex,entityIndex,visuInfo.createrVisuId);
	return 1;	  
      }
    }
    else
      printf(" agent index %d bigger than max allowed %d\n",agentIndex,SPARK_VISU_AGENT_MAX);
  }
  return 0;
}


ACTIVITY_EVENT
sparkUpdateVisuInfoInPosterMain(SPARK_VISU_INFO_INPUT* visuInfoInput, int *report)
{
  // printf("size of poster num  %d\n",sizeof(SDI_F->visualizationsInfo.numVisusInfo));
  // printf("size of poster 1st element  %d\n",sizeof(SDI_F->visualizationsInfo.visusInfos[0]));
  // printf("size of poster %d\n",sizeof(SDI_F->visualizationsInfo));
  
  /////////////////////////////
  // Need to change params
  /////////////////////////////
  SPARK_VISU_INFO_PARAM_CHANGE_TYPE type = visuInfoInput->autoVisuInSparkManagementParamChangeType;
  double doubleParam = visuInfoInput->autoVisuInSparkManagementDoubleParam;
  if(type == SPARK_VISU_INFO_PARAM_NO_PARAM_CHANGE){
    int res = UpdateSomeVisuInfo( visuInfoInput->addVisuInfo ,visuInfoInput->visuInfo );
    //printf(" UpdateSomeVisuInfo res =  %d\n", res);
    if(res > -4)
      *report = res;
    publishVisuInfoPoster();
  }
  else{
    if (type == SPARK_VISU_INFO_PARAM_REACH_RADIUS){
      SDI_F->visuInfoManagement.radius = doubleParam;
      printf(" Change radius to =  %f\n", doubleParam);
    }
    else if (type == SPARK_VISU_INFO_PARAM_REACH_ZOFFSET){
      SDI_F->visuInfoManagement.verticalOffSet.z = doubleParam;
      printf(" Change z offset to =  %f\n", doubleParam);
    }
    else if (type == SPARK_VISU_INFO_PARAM_REACH_DIST_BETWEEN_AGENTS_SPHERES){
      SDI_F->visuInfoManagement.distBetweenSphereCenters = doubleParam;
      //update horizontal offset
      for(int i = 0; i < SPARK_VISU_AGENT_MAX ; i++){
	SDI_F->visuInfoManagement.horizontalOffSet[i].x = -(SPARK_VISU_AGENT_MAX-1)*SDI_F->visuInfoManagement.distBetweenSphereCenters/2 +i*SDI_F->visuInfoManagement.distBetweenSphereCenters;
      }
      printf(" Change dist between sphere centers to =  %f\n", doubleParam);
    }
    else if (type == SPARK_VISU_INFO_PARAM_REACH_MAX_DIST_BEFORE_UPDATE){
        SDI_F->visuInfoManagement.distMaxBeforeUpdate = doubleParam;
	printf(" Change max dist sphere center move before update to =  %f\n", doubleParam);
   }	    
    else if (type == SPARK_VISU_INFO_PARAM_SWITCH_SHOW_REACHABILITY){
      if(SDI_F->visuInfoManagement.showReachability)
	SDI_F->visuInfoManagement.showReachability = GEN_FALSE;
      else
	SDI_F->visuInfoManagement.showReachability = GEN_TRUE;
    }
    else if (type == SPARK_VISU_INFO_PARAM_SWITCH_SHOW_DIVERGENT_BELIEFS){
      if(SDI_F->visuInfoManagement.showDivergentBelief)
	SDI_F->visuInfoManagement.showDivergentBelief = GEN_FALSE;
      else
	SDI_F->visuInfoManagement.showDivergentBelief = GEN_TRUE;
    }
    else if (type == SPARK_VISU_INFO_PARAM_SWITCH_SHOW_TABLE_POINTS){
      if(SDI_F->visuInfoManagement.showTablePoints)
	SDI_F->visuInfoManagement.showTablePoints = GEN_FALSE;
      else
	SDI_F->visuInfoManagement.showTablePoints = GEN_TRUE;
    }
    
  }


    
  return ETHER;  
}


void fillVisuInfoPoster( void )
{ 
  SDI_F->visualizationsInfo.visusInfos[0].isVisuActive = 1;
  SDI_F->visualizationsInfo.visusInfos[0].point1.x = 6.0;
  SDI_F->visualizationsInfo.visusInfos[0].point1.y = 6.0;
  SDI_F->visualizationsInfo.visusInfos[0].point1.z = 1.0;
  SDI_F->visualizationsInfo.visusInfos[0].opacity = 1.0;
  SDI_F->visualizationsInfo.visusInfos[0].radius = 1.0;
  SDI_F->visualizationsInfo.visusInfos[0].type = SPARK_VISU_INFO_SPHERE;
  SDI_F->visualizationsInfo.visusInfos[0].createrId = 0;
}


#if defined(USE_MIGHTABILITY_MAPS)


/* Mightability Analyses Codels */
ACTIVITY_EVENT
sparkInit_MightabilityStart(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkInit_MightabilityMain(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{
 
  Create_and_init_Mightability_Maps(MM_around_obj->around_obj_name);
 
  SDI_F->state.mightabilitiesEnabled=1;
  printf(">>>>> After Create_and_init_Mightability_Maps(), SDI_F->state.mightabilitiesEnabled=%d\n",SDI_F->state.mightabilitiesEnabled);
  return END;
}

ACTIVITY_EVENT
sparkInit_MightabilityInter(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkInit_MightabilityEnd(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

  return ETHER;
}

//To Update Mightabilities
ACTIVITY_EVENT
sparkUpdate_MightabilityStart(int *report)
{
  if(SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED==1)
    {
      SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE=0;//Set to false
      return EXEC;
    }
  else
    {
      printf(" Mightability Analysis is NOT Initialized so Mightability will not be updated\n");
      return END;
    }
}

ACTIVITY_EVENT
sparkUpdate_MightabilityMain(int *report)
{
  if(SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE==0)
    {

      execute_Mightability_Map_functions();
      return EXEC;
    }

  if(SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE==1)
    {
      return END;
    }
 
  return EXEC;
}

ACTIVITY_EVENT
sparkUpdate_MightabilityInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkUpdate_MightabilityEnd(int *report)
{
  printf(" Existing from Update_Mightability loop, you need to call this request again to restart the loop \n"); 
  return ETHER;
}

//To SET the flags related to Update Mightabilities
ACTIVITY_EVENT
sparkSet_Mightability_flagsStart(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
  return EXEC;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsMain(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
  printf(" Mightability Flags are set : SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED=%d,  SDI_F->MA_FLAGS.SATRT_MIGHTABILITY_UPDATE=%d, SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE=%d, SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE=%d\n", SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED, SDI_F->MA_FLAGS.SATRT_MIGHTABILITY_UPDATE, SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE, SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE);
  return END;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsInter(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsEnd(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
 
  return ETHER;
}

//// Agent State Analysis Codels

//Init Agen State Analysis
ACTIVITY_EVENT
sparkInitAgentStateAnalysisStart(int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisMain(int *report)
{
  init_agents_for_MA_and_ASA();

  char threshold_file_path[150];
  char *home_dir=getenv("HOME");
  printf(" Home directory is %s\n",home_dir);
  strcpy(threshold_file_path,home_dir);
  char threshold_file_name[50]="/Human_State_Analysis_Thresholds.txt";
  strcat(threshold_file_path,threshold_file_name);
  
  //"/home/akpandey/Human_State_Analysis_Thresholds.txt";
  prepare_for_Agent_State_Analysis(threshold_file_path);
  return END;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}

//Reload Threshold for Agent State Analysis
ACTIVITY_EVENT
sparkReloadThresholdForASAStart(int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAMain(int *report)
{

  char threshold_file_path[150];
  char *home_dir=getenv("HOME");
  printf(" Home directory is %s\n",home_dir);
  strcpy(threshold_file_path,home_dir);
  char threshold_file_name[50]="/Human_State_Analysis_Thresholds.txt";
  strcat(threshold_file_path,threshold_file_name);
  
  //"/home/akpandey/Human_State_Analysis_Thresholds.txt";
  init_thresholds_for_ASA(threshold_file_path);
  return END;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAEnd(int *report)
{

  return ETHER;
}


//StartAgentStateAnalysis
ACTIVITY_EVENT
sparkStartAgentStateAnalysisStart(int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisMain(int *report)
{

  if(STOP_AGENT_STATE_ANALYSIS==1)
    {
      printf(" STOP Agent State Analysis\n");
      STOP_AGENT_STATE_ANALYSIS=0;
      return END;
    }
  if ( (NewDataForASA==1) || (NewDataForASA==4)) {
    hri_execute_Agent_State_Analysis_functions();
    if (NewDataForASA==4)
      NewDataForASA=3;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}

//StopAgentStateAnalysis

ACTIVITY_EVENT
sparkStopAgentStateAnalysisStart(int *report)
{
  STOP_AGENT_STATE_ANALYSIS=1;
  return EXEC;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisMain(int *report)
{
 
  return END;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}

void printAgentsActivityFacts(int for_agent)
{

  printf(" ========= Status for agent %s =======\n",gEnv->robot[Ag_Activity_Fact[HUMAN1_MA].agent_index]->name);

  printf(" Whole Body : %d \n",Ag_Activity_Fact[for_agent].whole_body);
  printf(" Torso: %d \n",Ag_Activity_Fact[for_agent].torso);
  printf(" Head: %d \n",Ag_Activity_Fact[for_agent].head);
    
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand);
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand_mode);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand_mode);
}


ACTIVITY_EVENT
sparkPrintAgentStateAnalysisStart(int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisMain(int *report)
{
  if(PRINT_AGENT_STATE_FACTS==1)
    {
      PRINT_AGENT_STATE_FACTS=0;
    }
  else
    {
      PRINT_AGENT_STATE_FACTS=1;
    }
 
  ////printAgentsActivityFacts(HUMAN1_MA);
  return END;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}


//// To get the human facts by name
void get_human_facts_in(Agent_Activity_fact_by_names &Hum_facts_by_name, STRUCT_AGENT_ACTIVITY_FACTS *hum_activity_fact)
{
  strcpy(hum_activity_fact->agent_name,Hum_facts_by_name.agent_name);
  strcpy(hum_activity_fact->agent_motion,Hum_facts_by_name.agent_motion);
  strcpy(hum_activity_fact->body_turn,Hum_facts_by_name.body_turn);
  strcpy(hum_activity_fact->torso_turn,Hum_facts_by_name.torso_turn);
  strcpy(hum_activity_fact->head_turn,Hum_facts_by_name.head_turn);
  strcpy(hum_activity_fact->right_hand_status,Hum_facts_by_name.right_hand_status);
  strcpy(hum_activity_fact->right_hand_config_mode,Hum_facts_by_name.right_hand_config_mode);
  strcpy(hum_activity_fact->right_hand_occup_mode,Hum_facts_by_name.right_hand_occup_mode);
  strcpy(hum_activity_fact->right_hand_rest_mode_type,Hum_facts_by_name.right_hand_rest_mode_type);
  strcpy(hum_activity_fact->right_hand_on_support,Hum_facts_by_name.right_hand_on_support);
  strcpy(hum_activity_fact->right_hand_holding_object,Hum_facts_by_name.right_hand_holding_object);
  strcpy(hum_activity_fact->left_hand_status,Hum_facts_by_name.left_hand_status);
  strcpy(hum_activity_fact->left_hand_config_mode,Hum_facts_by_name.left_hand_config_mode);
  strcpy(hum_activity_fact->left_hand_occup_mode,Hum_facts_by_name.left_hand_occup_mode);
  strcpy(hum_activity_fact->left_hand_rest_mode_type,Hum_facts_by_name.left_hand_rest_mode_type);
  strcpy(hum_activity_fact->left_hand_on_support,Hum_facts_by_name.left_hand_on_support);
  strcpy(hum_activity_fact->left_hand_holding_object,Hum_facts_by_name.left_hand_holding_object);

}

ACTIVITY_EVENT
sparkGetHumanFactsByNameStart(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact, int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameMain(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{
 
  get_human_facts_in(Hum_facts_by_name[HUMAN1_MA],&hum_activity_fact->Agent_Facts[HUMAN1_MA]);

#ifdef HUMAN2_EXISTS_FOR_MA
  get_human_facts_in(Hum_facts_by_name[HUMAN2_MA],&hum_activity_fact->Agent_Facts[HUMAN2_MA]);
#endif
  return END;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameInter(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameEnd(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

  return ETHER;
}

//Codels related to show object facts

//StartShowObjectFacts
ACTIVITY_EVENT
sparkStartShowObjectFactsStart(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
  return EXEC;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsMain(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
  printf(" Inside sparkStartShowObjectFactsMain with flag: SDI_F->show_obj_fact_flag.show_arrow=%d  \n", SDI_F->show_obj_fact_flag.show_arrow);
  SHOW_OBJ_FACTS_BY_ARROW=SDI_F->show_obj_fact_flag.show_arrow;
  SHOW_OBJECT_FACTS=1;
  return END;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsInter(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsEnd(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
 
  return ETHER;
}
 
//ResetShowObjectFactsData
ACTIVITY_EVENT
sparkResetShowObjectFactsDataStart(int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataMain(int *report)
{
  init_object_facts_data();
  printf(" ... Done   init_object_facts_data()\n");
  return END;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataEnd(int *report)
{

  return ETHER;
}

//StopShowObjectFacts
ACTIVITY_EVENT
sparkStopShowObjectFactsStart(int *report)
{
 
  return EXEC;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsMain(int *report)
{
  SHOW_OBJECT_FACTS=0;
  return END;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsInter(int *report)
{
  return END;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsEnd(int *report)
{
  return ETHER;
}

#endif
